Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QWidget

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.gui.QWidget

All Implemented Interfaces:
  QPaintDeviceInterface, QtJambiInterface

Direct Known Subclasses:
  EffectWidget, QAbstractButton, QAbstractSlider, QAbstractSpinBox, QCalendarWidget, QComboBox, QDesktopWidget, QDialog, QDialogButtonBox, QDockWidget, QFocusFrame, QFrame, QGLWidget, QGroupBox, QLineEdit, QMainWindow, QMdiSubWindow, QMenu, QMenuBar, QPrintPreviewWidget, QProgressBar, QRubberBand, QSizeGrip, QSplashScreen, QSplitterHandle, QStatusBar, QSvgWidget, QTabBar, QTabWidget, QToolBar, QWebView, QWizardPage, QWorkspace, SeekSlider, VideoPlayer, VideoWidget, VolumeSlider

    public class QWidget

extends QObject
implements QPaintDeviceInterface

The `QWidget` class is the base class of all user interface objects. The widget is the atom of the user interface: it receives mouse, keyboard and other events from the window system, and paints a representation of itself on the screen. Every widget is rectangular, and they are sorted in a Z-order. A widget is clipped by its parent and by the widgets in front of it.

A widget that isn't embedded in a parent widget is called a window. Usually, windows have a frame and a title bar, although it is also possible to create windows without such decoration using suitable window flags). In Qt, `QMainWindow` and the various subclasses of `QDialog` are the most common window types.

Every widget's constructor accepts one or two standard arguments:

1. `QWidget *parent = 0` is the parent of the new widget. If it is 0 (the default), the new widget will be a window. If not, it will be a child of parent, and be constrained by parent's geometry (unless you specify `Qt::Window` as window flag).
2. `Qt::WindowFlags f = 0` (where available) sets the window flags; the default is suitable for almost all widgets, but to get, for example, a window without a window system frame, you must use special flags.

`QWidget` has many member functions, but some of them have little direct functionality; for example, `QWidget` has a font property, but never uses this itself. There are many subclasses which provide real functionality, such as `QLabel`, `QPushButton`, `QListWidget`, and `QTabWidget`.

## Top-Level and Child Widgets

A widget without a parent widget is always an independent window (top-level widget). For these widgets, `setWindowTitle()` and `setWindowIcon()` set the title bar and icon respectively.

Non-window widgets are child widgets, and are displayed within their parent widgets. Most widgets in Qt are mainly useful as child widgets. For example, it is possible to display a button as a top-level window, but most people prefer to put their buttons inside other widgets, such as `QDialog`.

The above diagram shows a `QGroupBox` widget being used to hold various child widgets in a layout provided by `QGridLayout`. The `QLabel` child widgets have been outlined to indicate their full sizes.

If you want to use a `QWidget` to hold child widgets you will usually want to add a layout to the parent `QWidget`. See Layout Classes for more information about these.

## Composite Widgets

When a widgets is used as a container to group a number of child widgets, it is known as a composite widget. These can be created by constructing a widget with the required visual properties - a `QFrame`, for example - and adding child widgets to it, usually managed by a layout. The above diagram shows such a composite widget that was created using Qt Designer.

Composite widgets can also be created by subclassing a standard widget, such as `QWidget` or `QFrame`, and adding the necessary layout and child widgets in the constructor of the subclass. Many of the examples provided with Qt use this approach, and it is also covered in the Qt Tutorial.

## Custom Widgets and Painting

Since `QWidget` is a subclass of `QPaintDevice`, subclasses can be used to display custom content that is composed using a series of painting operations with an instance of the `QPainter` class. This approach contrasts with the canvas-style approach used by the Graphics View Framework where items are added to a scene by the application and are rendered by the framework itself.

Each widget performs all painting operations from within its `paintEvent()` function. This is called whenever the widget needs to be redrawn, either as a result of some external change or when requested by the application.

The Analog Clock example shows how a simple widget can handle paint events.

## Size Hints and Size Policies

When implementing a new widget, it is almost always useful to reimplement `sizeHint()` to provide a reasonable default size for the widget and to set the correct size policy with `setSizePolicy()`.

By default, composite widgets which do not provide a size hint will be sized according to the space requirements of their child widgets.

The size policy lets you supply good default behavior for the layout management system, so that other widgets can contain and manage yours easily. The default size policy indicates that the size hint represents the preferred size of the widget, and this is often good enough for many widgets.

## Events

Widgets respond to events that are typically caused by user actions. Qt delivers events to widgets by calling specific event handler functions with instances of `QEvent` subclasses containing information about each event.

If your widget only contains child widgets, you probably do not need to implement any event handlers. If you want to detect a mouse click in a child widget call the child's `underMouse()` function inside the widget's `mousePressEvent()`.

The Scribble example implements a wider set of events to handle mouse movement, button presses, and window resizing.

You will need to supply the behavior and content for your own widgets, but here is a brief overview of the events that are relevant to `QWidget`, starting with the most common ones:

- `paintEvent()` is called whenever the widget needs to be repainted. Every widget which displays custom content must implement it. Painting using a `QPainter` can only take place in a `paintEvent()` or a function called by a `paintEvent()`.
- `resizeEvent()` is called when the widget has been resized.
- `mousePressEvent()` is called when a mouse button is pressed when the mouse is inside it, or when it has grabbed the mouse using `grabMouse()`.
- `mouseReleaseEvent()` is called when a mouse button is released. A widget receives mouse release events when it has received the corresponding mouse press event. This means that if the user presses the mouse inside your widget, then drags the mouse to somewhere else before releasing the mouse button, your widget receives the release event. There is one exception: if a popup menu appears while the mouse button is held down, this popup immediately steals the mouse events.
- `mouseDoubleClickEvent()` is called when the user double clicks in the widget. If the user double-clicks, the widget receives a mouse press event, a mouse release event and finally this event instead of a second mouse press event. (Some mouse move events may also be received if the user doesn't hold the mouse steady during this operation.) It is not possible to distinguish a click from a double click until the second click arrives. (This is one reason why most GUI books recommend that double clicks be an extension of single clicks, rather than trigger a different action.)

Widgets that accept keyboard input need to reimplement a few more event handlers:

- `keyPressEvent()` is called whenever a key is pressed, and again when a key has been held down long enough for it to auto-repeat. Note that the Tab and Shift+Tab keys are only passed to the widget if they are not used by the focus-change mechanisms. To force those keys to be processed by your widget, you must reimplement `QWidget::event()`.
- `focusInEvent()` is called when the widget gains keyboard focus (assuming you have called `setFocusPolicy()`). Well written widgets indicate that they own the keyboard focus in a clear but discreet way.
- `focusOutEvent()` is called when the widget loses keyboard focus.

Some widgets will also need to reimplement some of the less common event handlers:

- `mouseMoveEvent()` is called whenever the mouse moves while a button is held down. This can be useful during drag and drop operations. If you call setMouseTracking(true), you get mouse move events even when no buttons are held down. (See also the guide to Drag and Drop.)
- `keyReleaseEvent()` is called whenever a key is released, and also while it is held down if the key is auto-repeating. In that case the widget receives a pair of key release and key press events for every repeat. Note that the Tab and Shift+Tab keys are only passed to the widget if they are not used by the focus-change mechanisms. To force those keys to be processed by your widget, you must reimplement `QWidget::event()`.
- `wheelEvent()` is called whenever the user turns the mouse wheel while the widget has the focus.
- `enterEvent()` is called when the mouse enters the widget's screen space. (This excludes screen space owned by any children of the widget.)
- `leaveEvent()` is called when the mouse leaves the widget's screen space. Note that if the mouse enters a child widget it will not cause a leaveEvent.
- `moveEvent()` is called when the widget has been moved relative to its parent.
- `closeEvent()` is called when the user closes the widget (or when `close()` is called).

There are also some rather obscure events described in the `QEvent::Type` documentation. You need to reimplement `event()` directly to handle these. The default implementation of `event()` handles Tab and Shift+Tab (to move the keyboard focus), and passes on most other events to one of the more specialized handlers above.

Events and the mechanism used to deliver them are covered in the Events and Event Filters document.

## Groups of Functions and Properties

Context | Functions and Properties
--- | ---
Window functions | `show()`, `hide()`, `raise()`, `lower()`, `close()`.
Top-level windows | `windowModified`, `windowTitle`, `windowIcon`, `windowIconText`, `isActiveWindow`, `activateWindow()`, `minimized`, `showMinimized()`, `maximized`, `showMaximized()`, `fullScreen`, `showFullScreen()`, `showNormal()`.
Window contents | `update()`, `repaint()`, `scroll()`.
Geometry | `pos`, `x()`, `y()`, `rect`, `size`, `width()`, `height()`, `move()`, `resize()`, `sizePolicy`, `sizeHint()`, `minimumSizeHint()`, `updateGeometry()`, `layout()`, `frameGeometry`, `geometry`, `childrenRect`, `childrenRegion`, `adjustSize()`, `mapFromGlobal()`, `mapToGlobal()`, `mapFromParent()`, `mapToParent()`, `maximumSize`, `minimumSize`, `sizeIncrement`, `baseSize`, `setFixedSize()`
Mode | `visible`, `isVisibleTo()`, `enabled`, `isEnabledTo()`, `modal`, `isWindow()`, `mouseTracking`, `updatesEnabled`, `visibleRegion()`.
Look and feel | `style()`, `setStyle()`, `styleSheet`, `cursor`, `font`, `palette`, `backgroundRole()`, `setBackgroundRole()`, `fontInfo()`, `fontMetrics()`.
Keyboard focus functions | `focus`, `focusPolicy`, `setFocus()`, `clearFocus()`, `setTabOrder()`, `setFocusProxy()`, `focusNextChild()`, `focusPreviousChild()`.
Mouse and keyboard grabbing | `grabMouse()`, `releaseMouse()`, `grabKeyboard()`, `releaseKeyboard()`, `mouseGrabber()`, `keyboardGrabber()`.
Event handlers | `event()`, `mousePressEvent()`, `mouseReleaseEvent()`, `mouseDoubleClickEvent()`, `mouseMoveEvent()`, `keyPressEvent()`, `keyReleaseEvent()`, `focusInEvent()`, `focusOutEvent()`, `wheelEvent()`, `enterEvent()`, `leaveEvent()`, `paintEvent()`, `moveEvent()`, `resizeEvent()`, `closeEvent()`, `dragEnterEvent()`, `dragMoveEvent()`, `dragLeaveEvent()`, `dropEvent()`, `childEvent()`, `showEvent()`, `hideEvent()`, `customEvent()`. `changeEvent()`,
System functions | `parentWidget()`, `window()`, `setParent()`, `winId()`, find(), `metric()`.
Interactive help | `setToolTip()`, `setWhatsThis()`

## Widget Style Sheets

In addition to the standard widget styles for each platform, widgets can also be styled according to rules specified in a `style sheet`. This feature enables you to customize the appearance of specific widgets to provide visual cues to users about their purpose; for example, a button could be styled in a particular way to indicate that it performs a destructive action.

The use of widgets style sheets is described in more detail in Qt Style Sheets.

## Transparency and Double Buffering

From Qt 4.0, `QWidget` automatically double-buffers its painting, so there's no need to write double-buffering code in `paintEvent()` to avoid flicker. Additionally, it became possible for widgets to propagate their contents to children, in order to enable transparency effects, by setting the `Qt::WA_ContentsPropagated` widget attribute - this is now deprecated in Qt 4.1.

In Qt 4.1, the contents of parent widgets are propagated by default to each of their children. Custom widgets can be written to take advantage of this feature by only updating irregular regions (to create non-rectangular child widgets), or by using painting with colors that have less than the full alpha component. The following diagram shows how attributes and properties of a custom widget can be fine-tuned to achieve different effects.

In the above diagram, a semi-transparent rectangular child widget with an area removed is constructed and added to a parent widget (a `QLabel` showing a pixmap) then different properties and widget attributes are set to achieve different effects:

- The left widget has no additional properties or widget attributes set. This default state suits most custom widgets that use transparency or are irregularly-shaped, and that do not paint over their entire area with an opaque brush.
- The center widget has the `autoFillBackground` property set. This property is used with custom widgets that rely on the widget to supply a default background, and do not paint over their entire area with an opaque brush.
- The right widget has the `Qt::WA_OpaquePaintEvent` widget attribute set. This indicates that the widget will paint over its entire area with opaque colors. The widget's area will initially be uninitialized (represented in the diagram by a red diagonal grid pattern that shines through the overpainted area). This is useful for widgets that need to paint their own specialized contents quickly and that do not need a default filled background.

For rapidly updating custom widgets with simple background colors, such as real-time plotting or graphing widgets, it is better to define a suitable background color (using `setBackgroundRole()` with the `QPalette::Window` role), set the `autoFillBackground` property, and only implement the necessary drawing functionality in the widget's `paintEvent()`.

For rapidly updating custom widgets that constantly paint over their entire areas with opaque content, such as video streaming widgets, it is better to set the widget's `Qt::WA_OpaquePaintEvent` , avoiding any unnecessary overhead associated with repainting the widget's background.

If a widget has both the `Qt::WA_OpaquePaintEvent` widget attribute and the `autoFillBackground` property set, the `Qt::WA_OpaquePaintEvent` attribute takes precedence. You should choose just one of these depending on your requirements.

In Qt 4.1, the contents of parent widgets are also propagated to standard Qt widgets. This can lead to some unexpected results if the parent widget is decorated in a non-standard way, as shown in the diagram below.

The scope for customizing the painting behavior of standard Qt widgets, without resorting to subclassing, is slightly less than that possible for custom widgets. Usually, the desired appearance of a standard widget can be achieved by setting its `autoFillBackground` property.

See also:
  `QEvent`, `QPainter`, `QGridLayout`, and `QBoxLayout`.

Nested Class Summary
`static class` | `QWidget.RenderFlag` This enum describes how to render the widget when calling `QWidget::render()`.
`static class` | `QWidget.RenderFlags` This is a flags class for com.trolltech.qt.gui.QWidget.RenderFlag

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary
`QSignalEmitter.Signal1` | `customContextMenuRequested` This signal takes 1 generic argument(s).

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QWidget()` Constructs a widget which is a child of `parent`, with widget flags set to `f`.
`QWidget(QWidget parent)` Constructs a widget which is a child of `parent`, with widget flags set to `f`.
`QWidget(QWidget parent, Qt.WindowFlags f)` Constructs a widget which is a child of `parent`, with widget flags set to `f`.
`QWidget(QWidget parent, Qt.WindowType[] f)` Constructs a widget which is a child of `parent`, with widget flags set to `f`.

Method Summary
`boolean` | `acceptDrops()` This property holds whether drop events are enabled for this widget.
`java.lang.String` | `accessibleDescription()` This property holds the widget's description as seen by assistive technologies.
`java.lang.String` | `accessibleName()` This property holds the widget's name as seen by assistive technologies.
`protected void` | `actionEvent(QActionEvent arg__1)` This event handler is called with the given `event` whenever the widget's actions are changed.
`java.util.List` | `actions()` Returns the (possibly empty) list of this widget's actions.
`void` | `activateWindow()` Sets the top-level widget containing this widget to be the active window.
`void` | `addAction(QAction action)` Appends the action `action` to this widget's list of actions.
`void` | `addActions(java.util.List actions)` Appends the actions `actions` to this widget's list of actions.
`void` | `adjustSize()` Adjusts the size of the widget to fit the contents.
`boolean` | `autoFillBackground()` This property holds whether the widget background is filled automatically.
`QPalette.ColorRole` | `backgroundRole()` Returns the background role of the widget.
`QSize` | `baseSize()` This property holds the base size of the widget.
`protected void` | `changeEvent(QEvent arg__1)` This event handler can be reimplemented to handle state changes.
`QWidget` | `childAt(int x, int y)` Returns the visible child widget at the position (`x`, `y`) in the widget's coordinate system.
`QWidget` | `childAt(QPoint p)` Returns the visible child widget at point `p` in the widget's own coordinate system.
`QRect` | `childrenRect()` This property holds the bounding rectangle of the widget's children.
`QRegion` | `childrenRegion()` This property holds the combined region occupied by the widget's children.
`void` | `clearFocus()` Takes keyboard input focus from the widget.
`void` | `clearMask()` Removes any mask set by `setMask()`.
`boolean` | `close()` Closes this widget.
`protected void` | `closeEvent(QCloseEvent arg__1)` This event handler is called with the given `event` when Qt receives a window close request for a top-level widget from the window system.
`QRect` | `contentsRect()` Returns the area inside the widget's margins.
`protected void` | `contextMenuEvent(QContextMenuEvent arg__1)` This event handler, for event `event`, can be reimplemented in a subclass to receive widget context menu events.
`Qt.ContextMenuPolicy` | `contextMenuPolicy()` This property holds how the widget shows a context menu.
`QCursor` | `cursor()` This property holds the cursor shape for this widget.
`int` | `depth()` Returns the bit depth (number of bit planes) of the paint device.
`protected void` | `destroy()` Frees up window system resources.
`protected void` | `destroy(boolean destroyWindow)` Frees up window system resources.
`protected void` | `destroy(boolean destroyWindow, boolean destroySubWindows)` Frees up window system resources.
`protected void` | `dragEnterEvent(QDragEnterEvent arg__1)` This event handler is called when a drag is in progress and the mouse enters this widget.
`protected void` | `dragLeaveEvent(QDragLeaveEvent arg__1)` This event handler is called when a drag is in progress and the mouse leaves this widget.
`protected void` | `dragMoveEvent(QDragMoveEvent arg__1)` This event handler is called if a drag is in progress, and when any of the following conditions occur.
`protected void` | `dropEvent(QDropEvent arg__1)` This event handler is called when the drag is dropped on this widget.
`long` | `effectiveWinId()` Returns the effective window system identifier of the widget, i.
`void` | `ensurePolished()` Ensures that the widget has been polished by `QStyle` (i.e., has a proper font and palette).
`protected void` | `enterEvent(QEvent arg__1)` This event handler can be reimplemented in a subclass to receive widget enter events which are passed in the `event` parameter.
`protected void` | `focusInEvent(QFocusEvent arg__1)` This event handler can be reimplemented in a subclass to receive keyboard focus events (focus received) for the widget.
`protected boolean` | `focusNextChild()` Finds a new widget to give the keyboard focus to, as appropriate for Tab, and returns true if it can find a new widget, or false if it can't.
`protected boolean` | `focusNextPrevChild(boolean next)` Finds a new widget to give the keyboard focus to, as appropriate for Tab and Shift+Tab, and returns true if it can find a new widget, or false if it can't.
`protected void` | `focusOutEvent(QFocusEvent arg__1)` This event handler can be reimplemented in a subclass to receive keyboard focus events (focus lost) for the widget.
`Qt.FocusPolicy` | `focusPolicy()` This property holds the way the widget accepts keyboard focus.
`protected boolean` | `focusPreviousChild()` Finds a new widget to give the keyboard focus to, as appropriate for Shift+Tab, and returns true if it can find a new widget, or false if it can't.
`QWidget` | `focusProxy()` Returns the focus proxy, or 0 if there is no focus proxy.
`QWidget` | `focusWidget()` Returns the last child of this widget that setFocus had been called on.
`QFont` | `font()` This property holds the font currently set for the widget.
`QFontInfo` | `fontInfo()` Returns the font info for the widget's current font.
`QFontMetrics` | `fontMetrics()` Returns the font metrics for the widget's current font.
`QPalette.ColorRole` | `foregroundRole()` Returns the foreground role.
`QRect` | `frameGeometry()` This property holds geometry of the widget relative to its parent including any window frame.
`QSize` | `frameSize()` This property holds the size of the widget including any window frame.
`QRect` | `geometry()` This property holds the geometry of the widget relative to its parent and excluding the window frame.
`com.trolltech.qt.gui.QContentsMargins` | `getContentsMargins()` Returns the widget's contents margins.
`void` | `grabKeyboard()` Grabs the keyboard input.
`void` | `grabMouse()` Grabs the mouse input.
`void` | `grabMouse(QCursor arg__1)` Grabs the mouse input and changes the cursor shape.
`int` | `grabShortcut(QKeySequence key)` Adds a shortcut to Qt's shortcut system that watches for the given `key` sequence in the given `context`.
`int` | `grabShortcut(QKeySequence key, Qt.ShortcutContext context)` Adds a shortcut to Qt's shortcut system that watches for the given `key` sequence in the given `context`.
`boolean` | `hasFocus()` This property holds whether this widget (or its focus proxy) has the keyboard input focus.
`boolean` | `hasMouseTracking()` This property holds whether mouse tracking is enabled for the widget.
`int` | `height()` Returns the height of the paint device in default coordinate system units (e.
`int` | `heightForWidth(int arg__1)` Returns the preferred height for this widget, given the width `w`.
`int` | `heightMM()` Returns the height of the paint device in millimeters.
`void` | `hide()` Hides the widget.
`protected void` | `hideEvent(QHideEvent arg__1)` This event handler can be reimplemented in a subclass to receive widget hide events.
`QInputContext` | `inputContext()` This function returns the `QInputContext` for this widget.
`protected void` | `inputMethodEvent(QInputMethodEvent arg__1)` This event handler, for event `event`, can be reimplemented in a subclass to receive Input Method composition events.
`java.lang.Object` | `inputMethodQuery(Qt.InputMethodQuery arg__1)` This method is only relevant for input widgets.
`void` | `insertAction(QAction before, QAction action)` Inserts the action `action` to this widget's list of actions, before the action `before`.
`void` | `insertActions(QAction before, java.util.List actions)` Inserts the actions `actions` to this widget's list of actions, before the action `before`.
`boolean` | `isActiveWindow()` This property holds whether this widget's window is the active window.
`boolean` | `isAncestorOf(QWidget child)` Returns true if this widget is a parent, (or grandparent and so on to any level), of the given `child`, and both widgets are within the same window; otherwise returns false.
`boolean` | `isEnabled()` This property holds whether the widget is enabled.
`boolean` | `isEnabledTo(QWidget arg__1)` Returns true if this widget would become enabled if `ancestor` is enabled; otherwise returns false.
`boolean` | `isFullScreen()` This property holds whether the widget is shown in full screen mode.
`boolean` | `isHidden()` Returns true if the widget is hidden, otherwise returns false.
`boolean` | `isMaximized()` This property holds whether this widget is maximized.
`boolean` | `isMinimized()` This property holds whether this widget is minimized (iconified).
`boolean` | `isModal()` This property holds whether the widget is a modal widget.
`boolean` | `isVisible()` This property holds whether the widget is visible.
`boolean` | `isVisibleTo(QWidget arg__1)` Returns true if this widget would become visible if `ancestor` is shown; otherwise returns false.
`boolean` | `isWindow()` Returns true if the widget is an independent window, otherwise returns false.
`boolean` | `isWindowModified()` This property holds whether the document shown in the window has unsaved changes.
`static QWidget` | `keyboardGrabber()` Returns the widget that is currently grabbing the keyboard input.
`protected void` | `keyPressEvent(QKeyEvent arg__1)` This event handler, for event `event`, can be reimplemented in a subclass to receive key press events for the widget.
`protected void` | `keyReleaseEvent(QKeyEvent arg__1)` This event handler, for event `event`, can be reimplemented in a subclass to receive key release events for the widget.
`protected void` | `languageChange()`
`QLayout` | `layout()` Returns the layout manager that is installed on this widget, or 0 if no layout manager is installed.
`Qt.LayoutDirection` | `layoutDirection()` This property holds the layout direction for this widget.
`protected void` | `leaveEvent(QEvent arg__1)` This event handler can be reimplemented in a subclass to receive widget leave events which are passed in the `event` parameter.
`QLocale` | `locale()` This property holds the widget's locale.
`int` | `logicalDpiX()` Returns the horizontal resolution of the device in dots per inch, which is used when computing font sizes.
`int` | `logicalDpiY()` Returns the vertical resolution of the device in dots per inch, which is used when computing font sizes.
`void` | `lower()` Lowers the widget to the bottom of the parent widget's stack.
`QPoint` | `mapFrom(QWidget arg__1, QPoint arg__2)` Translates the widget coordinate `pos` from the coordinate system of `parent` to this widget's coordinate system.
`QPoint` | `mapFromGlobal(QPoint arg__1)` Translates the global screen coordinate `pos` to widget coordinates.
`QPoint` | `mapFromParent(QPoint arg__1)` Translates the parent widget coordinate `pos` to widget coordinates.
`QPoint` | `mapTo(QWidget arg__1, QPoint arg__2)` Translates the widget coordinate `pos` to the coordinate system of `parent`.
`QPoint` | `mapToGlobal(QPoint arg__1)` Translates the widget coordinate `pos` to global screen coordinates.
`QPoint` | `mapToParent(QPoint arg__1)` Translates the widget coordinate `pos` to a coordinate in the parent widget.
`QRegion` | `mask()` Returns the mask currently set on a widget.
`int` | `maximumHeight()` This property holds the widget's maximum height in pixels.
`QSize` | `maximumSize()` This property holds the widget's maximum size in pixels.
`int` | `maximumWidth()` This property holds the widget's maximum width in pixels.
`int` | `metric(QPaintDevice.PaintDeviceMetric arg__1)` Returns the metric information for the given paint device `metric`.
`int` | `minimumHeight()` This property holds the widget's minimum height in pixels.
`QSize` | `minimumSize()` This property holds the widget's minimum size.
`QSize` | `minimumSizeHint()` This property holds the recommended minimum size for the widget.
`int` | `minimumWidth()` This property holds the widget's minimum width in pixels.
`protected void` | `mouseDoubleClickEvent(QMouseEvent arg__1)` This event handler, for event `event`, can be reimplemented in a subclass to receive mouse double click events for the widget.
`static QWidget` | `mouseGrabber()` Returns the widget that is currently grabbing the mouse input.
`protected void` | `mouseMoveEvent(QMouseEvent arg__1)` This event handler, for event `event`, can be reimplemented in a subclass to receive mouse move events for the widget.
`protected void` | `mousePressEvent(QMouseEvent arg__1)` This event handler, for event `event`, can be reimplemented in a subclass to receive mouse press events for the widget.
`protected void` | `mouseReleaseEvent(QMouseEvent arg__1)` This event handler, for event `event`, can be reimplemented in a subclass to receive mouse release events for the widget.
`void` | `move(int x, int y)` This property holds the position of the widget within its parent widget.
`void` | `move(QPoint arg__1)` This property holds the position of the widget within its parent widget.
`protected void` | `moveEvent(QMoveEvent arg__1)` This event handler can be reimplemented in a subclass to receive widget move events which are passed in the `event` parameter.
`QWidget` | `nativeParentWidget()` Returns the native parent for this widget, i.
`QWidget` | `nextInFocusChain()` Returns the next widget in this widget's focus chain.
`QRect` | `normalGeometry()` This property holds the geometry of the widget as it will appear when shown as a normal (not maximized or full screen) top-level widget.
`int` | `numColors()` Returns the number of different colors available for the paint device.
`void` | `overrideWindowFlags(Qt.WindowFlags type)` Sets the window flags for the widget to `flags`, without telling the window system.
`void` | `overrideWindowFlags(Qt.WindowType[] type)` Sets the window flags for the widget to `flags`, without telling the window system.
`QPaintEngine` | `paintEngine()` Returns a pointer to the paint engine used for drawing on the device.
`protected void` | `paintEvent(QPaintEvent arg__1)` This event handler can be reimplemented in a subclass to receive paint events which are passed in the `event` parameter.
`boolean` | `paintingActive()` Returns true if the device is currently being painted on, i.
`QPalette` | `palette()` This property holds the widget's palette.
`QWidget` | `parentWidget()` Returns the parent of this widget, or 0 if it does not have any parent widget.
`int` | `physicalDpiX()` Returns the horizontal resolution of the device in dots per inch.
`int` | `physicalDpiY()` Returns the horizontal resolution of the device in dots per inch.
`QPoint` | `pos()` This property holds the position of the widget within its parent widget.
`void` | `raise()` Raises this widget to the top of the parent widget's stack.
`QRect` | `rect()` This property holds the internal geometry of the widget excluding any window frame.
`void` | `releaseKeyboard()` Releases the keyboard grab.
`void` | `releaseMouse()` Releases the mouse grab.
`void` | `releaseShortcut(int id)` Removes the shortcut with the given `id` from Qt's shortcut system.
`void` | `removeAction(QAction action)` Removes the action `action` from this widget's list of actions.
`void` | `render(QPaintDeviceInterface target)` Renders the `sourceRegion` of this widget into the `target` using `renderFlags` to determine how to render.
`void` | `render(QPaintDeviceInterface target, QPoint targetOffset)` Renders the `sourceRegion` of this widget into the `target` using `renderFlags` to determine how to render.
`void` | `render(QPaintDeviceInterface target, QPoint targetOffset, QRegion sourceRegion)` Renders the `sourceRegion` of this widget into the `target` using `renderFlags` to determine how to render.
`void` | `render(QPaintDeviceInterface target, QPoint targetOffset, QRegion sourceRegion, QWidget.RenderFlag[] renderFlags)` Renders the `sourceRegion` of this widget into the `target` using `renderFlags` to determine how to render.
`void` | `render(QPaintDeviceInterface target, QPoint targetOffset, QRegion sourceRegion, QWidget.RenderFlags renderFlags)` Renders the `sourceRegion` of this widget into the `target` using `renderFlags` to determine how to render.
`void` | `render(QPainter painter, QPoint targetOffset)` Renders the widget into the `painter`'s `QPainter::device()`.
`void` | `render(QPainter painter, QPoint targetOffset, QRegion sourceRegion)` Renders the widget into the `painter`'s `QPainter::device()`.
`void` | `render(QPainter painter, QPoint targetOffset, QRegion sourceRegion, QWidget.RenderFlag[] renderFlags)` Renders the widget into the `painter`'s `QPainter::device()`.
`void` | `render(QPainter painter, QPoint targetOffset, QRegion sourceRegion, QWidget.RenderFlags renderFlags)` Renders the widget into the `painter`'s `QPainter::device()`.
`void` | `repaint()` Repaints the widget directly by calling `paintEvent()` immediately, unless updates are disabled or the widget is hidden.
`void` | `repaint(int x, int y, int w, int h)` This version repaints a rectangle (`x`, `y`, `w`, `h`) inside the widget.
`void` | `repaint(QRect arg__1)` This version repaints a rectangle `r` inside the widget.
`void` | `repaint(QRegion arg__1)` This version repaints a region `rgn` inside the widget.
`protected void` | `resetInputContext()` This function can be called on the widget that currently has focus to reset the input method operating on it.
`void` | `resize(int w, int h)` This property holds the size of the widget excluding any window frame.
`void` | `resize(QSize arg__1)` This property holds the size of the widget excluding any window frame.
`protected void` | `resizeEvent(QResizeEvent arg__1)` This event handler can be reimplemented in a subclass to receive widget resize events which are passed in the `event` parameter.
`boolean` | `restoreGeometry(QByteArray geometry)` Restores the geometry and state top-level widgets stored in the byte array `geometry`.
`QByteArray` | `saveGeometry()` Saves the current geometry and state for top-level widgets.
`void` | `scroll(int dx, int dy)` Scrolls the widget including its children `dx` pixels to the right and `dy` downward.
`void` | `scroll(int dx, int dy, QRect arg__3)` This version only scrolls `r` and does not move the children of the widget.
`void` | `setAcceptDrops(boolean on)` This property holds whether drop events are enabled for this widget.
`void` | `setAccessibleDescription(java.lang.String description)` This property holds the widget's description as seen by assistive technologies.
`void` | `setAccessibleName(java.lang.String name)` This property holds the widget's name as seen by assistive technologies.
`void` | `setAttribute(Qt.WidgetAttribute arg__1)` Sets the attribute `attribute` on this widget if `on` is true; otherwise clears the attribute.
`void` | `setAttribute(Qt.WidgetAttribute arg__1, boolean on)` Sets the attribute `attribute` on this widget if `on` is true; otherwise clears the attribute.
`void` | `setAutoFillBackground(boolean enabled)` This property holds whether the widget background is filled automatically.
`void` | `setBackgroundRole(QPalette.ColorRole arg__1)` Sets the background role of the widget to `role`.
`void` | `setBaseSize(int basew, int baseh)` This property holds the base size of the widget.
`void` | `setBaseSize(QSize arg__1)` This property holds the base size of the widget.
`void` | `setContentsMargins(int left, int top, int right, int bottom)` Sets the margins around the contents of the widget to have the sizes `left`, `top`, `right`, and `bottom`.
`void` | `setContentsMargins(com.trolltech.qt.gui.QContentsMargins margins)` Sets the `margins` around the contents of the widget.
`void` | `setContextMenuPolicy(Qt.ContextMenuPolicy policy)` This property holds how the widget shows a context menu.
`void` | `setCursor(QCursor arg__1)` This property holds the cursor shape for this widget.
`void` | `setDisabled(boolean arg__1)` Disables widget input events if `disable` is true; otherwise enables input events.
`void` | `setEnabled(boolean arg__1)` This property holds whether the widget is enabled.
`void` | `setFixedHeight(int h)` Sets both the minimum and maximum heights of the widget to `h` without changing the widths.
`void` | `setFixedSize(int w, int h)` Sets the width of the widget to `w` and the height to `h`.
`void` | `setFixedSize(QSize arg__1)` Sets both the minimum and maximum sizes of the widget to `s`, thereby preventing it from ever growing or shrinking.
`void` | `setFixedWidth(int w)` Sets both the minimum and maximum width of the widget to `w` without changing the heights.
`void` | `setFocus()` Gives the keyboard input focus to this widget (or its focus proxy) if this widget or one of its parents is the `active window`.
`void` | `setFocus(Qt.FocusReason reason)` Gives the keyboard input focus to this widget (or its focus proxy) if this widget or one of its parents is the `active window`.
`void` | `setFocusPolicy(Qt.FocusPolicy policy)` This property holds the way the widget accepts keyboard focus.
`void` | `setFocusProxy(QWidget arg__1)` Sets the widget's focus proxy to widget `w`.
`void` | `setFont(QFont arg__1)` This property holds the font currently set for the widget.
`void` | `setForegroundRole(QPalette.ColorRole arg__1)` Sets the foreground role of the widget to `role`.
`void` | `setGeometry(int x, int y, int w, int h)` This property holds the geometry of the widget relative to its parent and excluding the window frame.
`void` | `setGeometry(QRect arg__1)` This property holds the geometry of the widget relative to its parent and excluding the window frame.
`void` | `setHidden(boolean hidden)` Convenience function, equivalent to setVisible(!`hidden`).
`void` | `setInputContext(QInputContext arg__1)` This function sets the input context `context` on this widget.
`void` | `setLayout(QLayout arg__1)` Sets the layout manager for this widget to `layout`.
`void` | `setLayoutDirection(Qt.LayoutDirection direction)` This property holds the layout direction for this widget.
`void` | `setLocale(QLocale locale)` This property holds the widget's locale.
`void` | `setMask(QBitmap arg__1)` Causes only the pixels of the widget for which `bitmap` has a corresponding 1 bit to be visible.
`void` | `setMask(QRegion arg__1)` Causes only the parts of the widget which overlap `region` to be visible.
`void` | `setMaximumHeight(int maxh)` This property holds the widget's maximum height in pixels.
`void` | `setMaximumSize(int maxw, int maxh)` This property holds the widget's maximum size in pixels.
`void` | `setMaximumSize(QSize arg__1)` This property holds the widget's maximum size in pixels.
`void` | `setMaximumWidth(int maxw)` This property holds the widget's maximum width in pixels.
`void` | `setMinimumHeight(int minh)` This property holds the widget's minimum height in pixels.
`void` | `setMinimumSize(int minw, int minh)` This property holds the widget's minimum size.
`void` | `setMinimumSize(QSize arg__1)` This property holds the widget's minimum size.
`void` | `setMinimumWidth(int minw)` This property holds the widget's minimum width in pixels.
`void` | `setMouseTracking(boolean enable)` This property holds whether mouse tracking is enabled for the widget.
`void` | `setPalette(QPalette arg__1)` This property holds the widget's palette.
`void` | `setParent(QWidget parent)` Sets the parent of the widget to `parent`, and resets the window flags.
`void` | `setParent(QWidget parent, Qt.WindowFlags f)` This function also takes widget flags, `f` as an argument.
`void` | `setParent(QWidget parent, Qt.WindowType[] f)` This function also takes widget flags, `f` as an argument.
`void` | `setShortcutAutoRepeat(int id)` If `enable` is true, auto repeat of the shortcut with the given `id` is enabled; otherwise it is disabled.
`void` | `setShortcutAutoRepeat(int id, boolean enable)` If `enable` is true, auto repeat of the shortcut with the given `id` is enabled; otherwise it is disabled.
`void` | `setShortcutEnabled(int id)` If `enable` is true, the shortcut with the given `id` is enabled; otherwise the shortcut is disabled.
`void` | `setShortcutEnabled(int id, boolean enable)` If `enable` is true, the shortcut with the given `id` is enabled; otherwise the shortcut is disabled.
`void` | `setSizeIncrement(int w, int h)` This property holds the size increment of the widget.
`void` | `setSizeIncrement(QSize arg__1)` This property holds the size increment of the widget.
`void` | `setSizePolicy(QSizePolicy.Policy horizontal, QSizePolicy.Policy vertical)` This property holds the default layout behavior of the widget.
`void` | `setSizePolicy(QSizePolicy arg__1)` This property holds the default layout behavior of the widget.
`void` | `setStatusTip(java.lang.String arg__1)` This property holds the widget's status tip.
`void` | `setStyle(QStyle arg__1)` Sets the widget's GUI style to `style`.
`void` | `setStyleSheet(java.lang.String styleSheet)` This property holds the widget's style sheet.
`static void` | `setTabOrder(QWidget arg__1, QWidget arg__2)` Moves the `second` widget around the ring of focus widgets so that keyboard focus moves from the `first` widget to the `second` widget when the Tab key is pressed.
`void` | `setToolTip(java.lang.String arg__1)` This property holds the widget's tooltip.
`void` | `setUpdatesEnabled(boolean enable)` This property holds whether updates are enabled.
`void` | `setVisible(boolean visible)` This property holds whether the widget is visible.
`void` | `setWhatsThis(java.lang.String arg__1)` This property holds the widget's What's This help text.
`void` | `setWindowFilePath(java.lang.String filePath)` This property holds the file path associated with a widget.
`void` | `setWindowFlags(Qt.WindowFlags type)` Window flags are a combination of a type (e.
`void` | `setWindowFlags(Qt.WindowType[] type)` Window flags are a combination of a type (e.
`void` | `setWindowIcon(QIcon icon)` This property holds the widget's icon.
`void` | `setWindowIconText(java.lang.String arg__1)` This property holds the widget's icon text.
`void` | `setWindowModality(Qt.WindowModality windowModality)` This property holds which windows are blocked by the modal widget.
`void` | `setWindowModified(boolean arg__1)` This property holds whether the document shown in the window has unsaved changes.
`void` | `setWindowOpacity(double level)` This property holds The level of opacity for the window.
`void` | `setWindowRole(java.lang.String arg__1)` Sets the window's role to `role`.
`void` | `setWindowState(Qt.WindowState[] state)` Sets the window state to `windowState`.
`void` | `setWindowState(Qt.WindowStates state)` Sets the window state to `windowState`.
`void` | `setWindowTitle(java.lang.String arg__1)` This property holds the window title (caption).
`void` | `show()` Shows the widget and its child widgets.
`protected void` | `showEvent(QShowEvent arg__1)` This event handler can be reimplemented in a subclass to receive widget show events which are passed in the `event` parameter.
`void` | `showFullScreen()` Shows the widget in full-screen mode.
`void` | `showMaximized()` Shows the widget maximized.
`void` | `showMinimized()` Shows the widget minimized, as an icon.
`void` | `showNormal()` Restores the widget after it has been maximized or minimized.
`QSize` | `size()` This property holds the size of the widget excluding any window frame.
`QSize` | `sizeHint()` This property holds the recommended size for the widget.
`QSize` | `sizeIncrement()` This property holds the size increment of the widget.
`QSizePolicy` | `sizePolicy()` This property holds the default layout behavior of the widget.
`void` | `stackUnder(QWidget arg__1)` Places the widget under `w` in the parent widget's stack.
`java.lang.String` | `statusTip()` This property holds the widget's status tip.
`QStyle` | `style()` Returns the widget's style object, i.e., the style in which the widget is drawn.
`java.lang.String` | `styleSheet()` This property holds the widget's style sheet.
`protected void` | `tabletEvent(QTabletEvent arg__1)` This event handler, for event `event`, can be reimplemented in a subclass to receive tablet events for the widget.
`boolean` | `testAttribute(Qt.WidgetAttribute arg__1)` Returns true if attribute `attribute` is set on this widget; otherwise returns false.
`java.lang.String` | `toolTip()` This property holds the widget's tooltip.
`boolean` | `underMouse()` Returns true if the widget is under the mouse cursor; otherwise returns false.
`void` | `unsetCursor()` This property holds the cursor shape for this widget.
`void` | `unsetLayoutDirection()` This property holds the layout direction for this widget.
`void` | `unsetLocale()` This property holds the widget's locale.
`void` | `update()` Updates the widget unless updates are disabled or the widget is hidden.
`void` | `update(int x, int y, int w, int h)` This version updates a rectangle (`x`, `y`, `w`, `h`) inside the widget.
`void` | `update(QRect arg__1)` This version updates a rectangle `r` inside the widget.
`void` | `update(QRegion arg__1)` This version repaints a region `rgn` inside the widget.
`void` | `updateGeometry()` Notifies the layout system that this widget has changed and may need to change geometry.
`protected void` | `updateMicroFocus()` Updates the widget's micro focus.
`boolean` | `updatesEnabled()` This property holds whether updates are enabled.
`QRegion` | `visibleRegion()` Returns the unobscured region where paint events can occur.
`java.lang.String` | `whatsThis()` This property holds the widget's What's This help text.
`protected void` | `wheelEvent(QWheelEvent arg__1)` This event handler, for event `event`, can be reimplemented in a subclass to receive wheel events for the widget.
`int` | `width()` Returns the width of the paint device in default coordinate system units (e.
`int` | `widthMM()` Returns the width of the paint device in millimeters.
`QWidget` | `window()` Returns the window for this widget, i.
`java.lang.String` | `windowFilePath()` This property holds the file path associated with a widget.
`Qt.WindowFlags` | `windowFlags()` Window flags are a combination of a type (e.
`QIcon` | `windowIcon()` This property holds the widget's icon.
`java.lang.String` | `windowIconText()` This property holds the widget's icon text.
`Qt.WindowModality` | `windowModality()` This property holds which windows are blocked by the modal widget.
`double` | `windowOpacity()` This property holds The level of opacity for the window.
`java.lang.String` | `windowRole()` Returns the window's role, or an empty string.
`Qt.WindowStates` | `windowState()` Returns the current window state.
`java.lang.String` | `windowTitle()` This property holds the window title (caption).
`Qt.WindowType` | `windowType()` Returns the window type of this widget.
`long` | `winId()` Returns the window system identifier of the widget.
`int` | `x()` This property holds the x coordinate of the widget relative to its parent including any window frame.
`int` | `y()` This property holds the y coordinate of the widget relative to its parent and including any window frame.

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### customContextMenuRequested

    public final QSignalEmitter.Signal1 customContextMenuRequested

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.core.QPoint(named: pos)>:

  This signal is emitted when the widget's `contextMenuPolicy` is `Qt::CustomContextMenu` , and the user has requested a context menu on the widget. The position `pos` is the position of the context menu event that the widget receives. Normally this is in widget coordinates. The exception to this rule is `QAbstractScrollArea` and its subclasses that map the context menu event to coordinates of the `viewport()` .

See also:
  `mapToGlobal()`, `QMenu`, and `contextMenuPolicy`.

Constructor Detail

### QWidget

    public QWidget(QWidget parent,
                   Qt.WindowType[] f)

  Constructs a widget which is a child of `parent`, with widget flags set to `f`.

  If `parent` is 0, the new widget becomes a window. If `parent` is another widget, this widget becomes a child window inside `parent`. The new widget is deleted when its `parent` is deleted.

  The widget flags argument, `f`, is normally 0, but it can be set to customize the frame of a window (i.e. `parent` must be 0). To customize the frame, use a value composed from the bitwise OR of any of the window flags.

  If you add a child widget to an already visible widget you must explicitly show the child to make it visible.

  Note that the X11 version of Qt may not be able to deliver all combinations of style flags on all systems. This is because on X11, Qt can only ask the window manager, and the window manager can override the application's settings. On Windows, Qt can set whatever flags you want.

See also:
  `windowFlags`.

### QWidget

    public QWidget(QWidget parent)

  Constructs a widget which is a child of `parent`, with widget flags set to `f`.

  If `parent` is 0, the new widget becomes a window. If `parent` is another widget, this widget becomes a child window inside `parent`. The new widget is deleted when its `parent` is deleted.

  The widget flags argument, `f`, is normally 0, but it can be set to customize the frame of a window (i.e. `parent` must be 0). To customize the frame, use a value composed from the bitwise OR of any of the window flags.

  If you add a child widget to an already visible widget you must explicitly show the child to make it visible.

  Note that the X11 version of Qt may not be able to deliver all combinations of style flags on all systems. This is because on X11, Qt can only ask the window manager, and the window manager can override the application's settings. On Windows, Qt can set whatever flags you want.

See also:
  `windowFlags`.

### QWidget

    public QWidget()

  Constructs a widget which is a child of `parent`, with widget flags set to `f`.

  If `parent` is 0, the new widget becomes a window. If `parent` is another widget, this widget becomes a child window inside `parent`. The new widget is deleted when its `parent` is deleted.

  The widget flags argument, `f`, is normally 0, but it can be set to customize the frame of a window (i.e. `parent` must be 0). To customize the frame, use a value composed from the bitwise OR of any of the window flags.

  If you add a child widget to an already visible widget you must explicitly show the child to make it visible.

  Note that the X11 version of Qt may not be able to deliver all combinations of style flags on all systems. This is because on X11, Qt can only ask the window manager, and the window manager can override the application's settings. On Windows, Qt can set whatever flags you want.

See also:
  `windowFlags`.

### QWidget

    public QWidget(QWidget parent,
                   Qt.WindowFlags f)

  Constructs a widget which is a child of `parent`, with widget flags set to `f`.

  If `parent` is 0, the new widget becomes a window. If `parent` is another widget, this widget becomes a child window inside `parent`. The new widget is deleted when its `parent` is deleted.

  The widget flags argument, `f`, is normally 0, but it can be set to customize the frame of a window (i.e. `parent` must be 0). To customize the frame, use a value composed from the bitwise OR of any of the window flags.

  If you add a child widget to an already visible widget you must explicitly show the child to make it visible.

  Note that the X11 version of Qt may not be able to deliver all combinations of style flags on all systems. This is because on X11, Qt can only ask the window manager, and the window manager can override the application's settings. On Windows, Qt can set whatever flags you want.

See also:
  `windowFlags`.

Method Detail

### acceptDrops

    public final boolean acceptDrops()

  This property holds whether drop events are enabled for this widget. Setting this property to true announces to the system that this widget may be able to accept drop events.

  If the widget is the desktop (`windowType()` == `Qt::Desktop` ), this may fail if another application is using the desktop; you can call `acceptDrops()` to test if this occurs.

  Warning: Do not modify this property in a drag and drop event handler.

  By default, this property is false.

See also:
  Drag and Drop.

### accessibleDescription

    public final java.lang.String accessibleDescription()

  This property holds the widget's description as seen by assistive technologies. By default, this property contains an empty string.

See also:
  `QAccessibleInterface::text()`.

### accessibleName

    public final java.lang.String accessibleName()

  This property holds the widget's name as seen by assistive technologies. This property is used by accessible clients to identify, find, or announce the widget for accessible clients.

  By default, this property contains an empty string.

See also:
  `QAccessibleInterface::text()`.

### actions

    public final java.util.List actions()

  Returns the (possibly empty) list of this widget's actions.

See also:
  `contextMenuPolicy`, `insertAction()`, and `removeAction()`.

### activateWindow

    public final void activateWindow()

  Sets the top-level widget containing this widget to be the active window.

  An active window is a visible top-level window that has the keyboard input focus.

  This function performs the same operation as clicking the mouse on the title bar of a top-level window. On X11, the result depends on the Window Manager. If you want to ensure that the window is stacked on top as well you should also call `raise()`. Note that the window must be visible, otherwise `activateWindow()` has no effect.

  On Windows, if you are calling this when the application is not currently the active one then it will not make it the active window. It will change the color of the taskbar entry to indicate that the window has changed in some way. This is because Microsoft do not allow an application to interrupt what the user is currently doing in another application.

See also:
  `isActiveWindow()`, `window()`, and `show()`.

### addAction

    public final void addAction(QAction action)

  Appends the action `action` to this widget's list of actions.

  All QWidgets have a list of `QAction`s, however they can be represented graphically in many different ways. The default use of the `QAction` list (as returned by `actions()`) is to create a context `QMenu`.

  A `QWidget` should only have one of each action and adding an action it already has will not cause the same action to be in the widget twice.

See also:
  `removeAction()`, `insertAction()`, `actions()`, and `QMenu`.

### addActions

    public final void addActions(java.util.List actions)

  Appends the actions `actions` to this widget's list of actions.

See also:
  `removeAction()`, `QMenu`, and `addAction()`.

### adjustSize

    public final void adjustSize()

  Adjusts the size of the widget to fit the contents.

  Uses `sizeHint()` if valid (i.e if the size hint's width and height are >= 0); otherwise sets the size to the children rectangle that covers all child widgets (the union of all child widget rectangles).

  For windows, the screen size is also taken into account, and if the `sizeHint()` is less than (200, 100) and the size policy is expanding, the window is made to be at least (200, 100).

See also:
  `sizeHint()`, and `childrenRect()`.

### autoFillBackground

    public final boolean autoFillBackground()

  This property holds whether the widget background is filled automatically. If enabled, this will cause Qt to fill the background of the widget before invoking the paint event. The color used is defined by the `QPalette::Window` color role from the widget's `palette`.

  In addition, Windows are always filled with `QPalette::Window` , unless the WA_OpaquePaintEvent or WA_NoSystemBackground attributes are set.

  Warning: Use this property with caution in conjunction with Qt Style Sheets. When a widget has a style sheet with a valid background or a border-image, this property is automatically disabled.

  By default, this property is false.

See also:
  `Qt::WA_OpaquePaintEvent` , `Qt::WA_NoSystemBackground` , and `Transparency and Double Buffering`.

### backgroundRole

    public final QPalette.ColorRole backgroundRole()

  Returns the background role of the widget.

  The background role defines the brush from the widget's `palette` that is used to render the background.

  If no explicit background role is set, the widget inherts its parent widget's background role.

See also:
  `setBackgroundRole()`, and `foregroundRole()`.

### baseSize

    public final QSize baseSize()

  This property holds the base size of the widget. The base size is used to calculate a proper widget size if the widget defines `sizeIncrement()`.

  By default, for a newly-created widget, this property contains a size with zero width and height.

See also:
  `setSizeIncrement()`.

### childAt

    public final QWidget childAt(QPoint p)

  Returns the visible child widget at point `p` in the widget's own coordinate system.

### childAt

    public final QWidget childAt(int x,
                                 int y)

  Returns the visible child widget at the position (`x`, `y`) in the widget's coordinate system. If there is no visible child widget at the specified position, the function returns 0.

### childrenRect

    public final QRect childrenRect()

  This property holds the bounding rectangle of the widget's children. Hidden children are excluded.

  By default, for a widget with no children, this property contains a rectangle with zero width and height located at the origin.

See also:
  `childrenRegion()`, and `geometry()`.

### childrenRegion

    public final QRegion childrenRegion()

  This property holds the combined region occupied by the widget's children. Hidden children are excluded.

  By default, for a widget with no children, this property contains an empty region.

See also:
  `childrenRect()`, `geometry()`, and `mask()`.

### clearFocus

    public final void clearFocus()

  Takes keyboard input focus from the widget.

  If the widget has active focus, a `focus out event` is sent to this widget to tell it that it is about to lose the focus.

  This widget must enable focus setting in order to get the keyboard input focus, i.e. it must call `setFocusPolicy()`.

See also:
  `hasFocus()`, `setFocus()`, `focusInEvent()`, `focusOutEvent()`, `setFocusPolicy()`, and `QApplication::focusWidget()`.

### clearMask

    public final void clearMask()

  Removes any mask set by `setMask()`.

See also:
  `setMask()`.

### close

    public final boolean close()

  Closes this widget. Returns true if the widget was closed; otherwise returns false.

  First it sends the widget a `QCloseEvent`. The widget is `hidden` if it `accepts` the close event. If it `ignores` the event, nothing happens. The default implementation of `QWidget::closeEvent()` accepts the close event.

  If the widget has the `Qt::WA_DeleteOnClose` flag, the widget is also deleted. A close events is delivered to the widget no matter if the widget is visible or not.

  The `QApplication::lastWindowClosed()` signal is emitted when the last visible primary window (i.e. window with no parent) with the `Qt::WA_QuitOnClose` attribute set is closed. By default this attribute is set for all widgets except transient windows such as splash screens, tool windows, and popup menus.

### contentsRect

    public final QRect contentsRect()

  Returns the area inside the widget's margins.

See also:
  `setContentsMargins()`, and `getContentsMargins()`.

### contextMenuPolicy

    public final Qt.ContextMenuPolicy contextMenuPolicy()

  This property holds how the widget shows a context menu. The default value of this property is `Qt::DefaultContextMenu` , which means the `contextMenuEvent()` handler is called. Other values are `Qt::NoContextMenu` , `Qt::PreventContextMenu` , `Qt::ActionsContextMenu` , and `Qt::CustomContextMenu` . With `Qt::CustomContextMenu` , the signal `customContextMenuRequested()` is emitted.

See also:
  `contextMenuEvent()`, `customContextMenuRequested()` , and `actions()`.

### cursor

    public final QCursor cursor()

  This property holds the cursor shape for this widget. The mouse cursor will assume this shape when it's over this widget. See the `list of predefined cursor objects` for a range of useful shapes.

  An editor widget might use an I-beam cursor:

              w.setCursor(new QCursor(Qt.CursorShape.IBeamCursor));

  If no cursor has been set, or after a call to `unsetCursor()`, the parent's cursor is used.

  By default, this property contains a cursor with the `Qt::ArrowCursor` shape.

See also:
  `QApplication::setOverrideCursor()`.

### depth

    public final int depth()

  Returns the bit depth (number of bit planes) of the paint device.

  Specified by:
    `depth` in interface `QPaintDeviceInterface`

### destroy

    protected final void destroy(boolean destroyWindow)

  Frees up window system resources. Destroys the widget window if `destroyWindow` is true.

  `destroy()` calls itself recursively for all the child widgets, passing `destroySubWindows` for the `destroyWindow` parameter. To have more control over destruction of subwidgets, destroy subwidgets selectively first.

  This function is usually called from the `QWidget` destructor.

### destroy

    protected final void destroy()

  Frees up window system resources. Destroys the widget window if `destroyWindow` is true.

  `destroy()` calls itself recursively for all the child widgets, passing `destroySubWindows` for the `destroyWindow` parameter. To have more control over destruction of subwidgets, destroy subwidgets selectively first.

  This function is usually called from the `QWidget` destructor.

### destroy

    protected final void destroy(boolean destroyWindow,
                                 boolean destroySubWindows)

  Frees up window system resources. Destroys the widget window if `destroyWindow` is true.

  `destroy()` calls itself recursively for all the child widgets, passing `destroySubWindows` for the `destroyWindow` parameter. To have more control over destruction of subwidgets, destroy subwidgets selectively first.

  This function is usually called from the `QWidget` destructor.

### effectiveWinId

    public final long effectiveWinId()

  Returns the effective window system identifier of the widget, i. . the native parent's window system identifier.

  Note: We recommend that you do not store this value as it is likely to change during run-time.

See also:
  `nativeParentWidget()`.

### ensurePolished

    public final void ensurePolished()

  Ensures that the widget has been polished by `QStyle` (i.e., has a proper font and palette).

  `QWidget` calls this function after it has been fully constructed but before it is shown the very first time. You can call this function if you want to ensure that the widget is polished before doing an operation, e.g., the correct font size might be needed in the widget's `sizeHint()` reimplementation. Note that this function is called from the default implementation of `sizeHint()`.

  Polishing is useful for final initialization that must happen after all constructors (from base classes as well as from subclasses) have been called.

  If you need to change some settings when a widget is polished, reimplement `event()` and handle the `QEvent::Polish` event type.

  Note: The function is declared const so that it can be called from other const functions (e.g., `sizeHint()`).

See also:
  `event()`.

### focusNextChild

    protected final boolean focusNextChild()

  Finds a new widget to give the keyboard focus to, as appropriate for Tab, and returns true if it can find a new widget, or false if it can't.

See also:
  `focusPreviousChild()`.

### focusPolicy

    public final Qt.FocusPolicy focusPolicy()

  This property holds the way the widget accepts keyboard focus. The policy is `Qt::TabFocus` if the widget accepts keyboard focus by tabbing, `Qt::ClickFocus` if the widget accepts focus by clicking, `Qt::StrongFocus` if it accepts both, and `Qt::NoFocus` (the default) if it does not accept focus at all.

  You must enable keyboard focus for a widget if it processes keyboard events. This is normally done from the widget's constructor. For instance, the `QLineEdit` constructor calls setFocusPolicy(`Qt::StrongFocus` ).

See also:
  `focusInEvent()`, `focusOutEvent()`, `keyPressEvent()`, `keyReleaseEvent()`, and `enabled`.

### focusPreviousChild

    protected final boolean focusPreviousChild()

  Finds a new widget to give the keyboard focus to, as appropriate for Shift+Tab, and returns true if it can find a new widget, or false if it can't.

See also:
  `focusNextChild()`.

### focusProxy

    public final QWidget focusProxy()

  Returns the focus proxy, or 0 if there is no focus proxy.

See also:
  `setFocusProxy()`.

### focusWidget

    public final QWidget focusWidget()

  Returns the last child of this widget that setFocus had been called on. For top level widgets this is the widget that will get focus in case this window gets activated

  This is not the same as `QApplication::focusWidget()`, which returns the focus widget in the currently active window.

### font

    public final QFont font()

  This property holds the font currently set for the widget. The `fontInfo()` function reports the actual font that is being used by the widget.

  As long as no special font has been set, or after setFont(QFont()) is called, this is either a special font for the widget class, the parent's font or (if this widget is a top level widget), the default application font.

  This code fragment sets a 12 point helvetica bold font:

              QFont fonti = new QFont("Helvetica", 12, QFont.Weight.Bold.value());
              w.setFont(font);

  Note that when a child widget is given a different font to that of its parent widget, it will still inherit the parent's font properties unless these have been set explicitly on the child's font. For example, if the parent's font is bold, the child widget's font will be bold as well if not specified otherwise like this:

              QFont font = new QFont();
              font.setBold(false);
              w.setFont(font);

  In addition to setting the font, `setFont()` informs all children about the change.

  Note: If Qt Style Sheets are used on the same widget as `setFont()`, style sheets will take precedence if the settings conflict.

See also:
  `fontInfo()`, and `fontMetrics()`.

### fontInfo

    public final QFontInfo fontInfo()

  Returns the font info for the widget's current font. Equivalent to QFontInto(widget->`font()`).

See also:
  `font()`, `fontMetrics()`, and `setFont()`.

### fontMetrics

    public final QFontMetrics fontMetrics()

  Returns the font metrics for the widget's current font. Equivalent to `QFontMetrics`(widget->`font()`).

See also:
  `font()`, `fontInfo()`, and `setFont()`.

### foregroundRole

    public final QPalette.ColorRole foregroundRole()

  Returns the foreground role.

  The foreground role defines the color from the widget's `palette` that is used to draw the foreground.

  If no explicit foreground role is set, the function returns a role that contrasts with the background role.

See also:
  `setForegroundRole()`, and `backgroundRole()`.

### frameGeometry

    public final QRect frameGeometry()

  This property holds geometry of the widget relative to its parent including any window frame. See the Window Geometry documentation for an overview of geometry issues with windows.

  By default, this property contains a value that depends on the user's platform and screen geometry.

See also:
  `geometry()`, `x()`, `y()`, and `pos()`.

### frameSize

    public final QSize frameSize()

  This property holds the size of the widget including any window frame. By default, this property contains a value that depends on the user's platform and screen geometry.

### geometry

    public final QRect geometry()

  This property holds the geometry of the widget relative to its parent and excluding the window frame. When changing the geometry, the widget, if visible, receives a move event (`moveEvent()`) and/or a resize event (`resizeEvent()`) immediately. If the widget is not currently visible, it is guaranteed to receive appropriate events before it is shown.

  The size component is adjusted if it lies outside the range defined by `minimumSize()` and `maximumSize()`.

  Warning: Calling `setGeometry()` inside `resizeEvent()` or `moveEvent()` can lead to infinite recursion.

  See the Window Geometry documentation for an overview of window geometry.

  By default, this property contains a value that depends on the user's platform and screen geometry.

See also:
  `frameGeometry()`, `rect()`, `move()`, `resize()`, `moveEvent()`, `resizeEvent()`, `minimumSize()`, and `maximumSize()`.

### grabKeyboard

    public final void grabKeyboard()

  Grabs the keyboard input.

  This widget receives all keyboard events until `releaseKeyboard()` is called; other widgets get no keyboard events at all. Mouse events are not affected. Use `grabMouse()` if you want to grab that.

  The focus widget is not affected, except that it doesn't receive any keyboard events. `setFocus()` moves the focus as usual, but the new focus widget receives keyboard events only after `releaseKeyboard()` is called.

  If a different widget is currently grabbing keyboard input, that widget's grab is released first.

See also:
  `releaseKeyboard()`, `grabMouse()`, `releaseMouse()`, and `focusWidget()`.

### grabMouse

    public final void grabMouse()

  Grabs the mouse input.

  This widget receives all mouse events until `releaseMouse()` is called; other widgets get no mouse events at all. Keyboard events are not affected. Use `grabKeyboard()` if you want to grab that.

  Warning: Bugs in mouse-grabbing applications very often lock the terminal. Use this function with extreme caution, and consider using the `-nograb` command line option while debugging.

  It is almost never necessary to grab the mouse when using Qt, as Qt grabs and releases it sensibly. In particular, Qt grabs the mouse when a mouse button is pressed and keeps it until the last button is released.

  Note that only visible widgets can grab mouse input. If `isVisible()` returns false for a widget, that widget cannot call `grabMouse()`.

  `focusWidget()`

See also:
  `releaseMouse()`, `grabKeyboard()`, `releaseKeyboard()`, and `grabKeyboard()`.

### grabMouse

    public final void grabMouse(QCursor arg__1)

  Grabs the mouse input and changes the cursor shape.

  The cursor will assume shape `cursor` (for as long as the mouse focus is grabbed) and this widget will be the only one to receive mouse events until `releaseMouse()` is called().

  Warning: Grabbing the mouse might lock the terminal.

See also:
  `releaseMouse()`, `grabKeyboard()`, `releaseKeyboard()`, and `setCursor()`.

### grabShortcut

    public final int grabShortcut(QKeySequence key)

  Adds a shortcut to Qt's shortcut system that watches for the given `key` sequence in the given `context`. If the `context` is `Qt::ApplicationShortcut` , the shortcut applies to the application as a whole. Otherwise, it is either local to this widget, `Qt::WidgetShortcut` , or to the window itself, `Qt::WindowShortcut` .

  If the same `key` sequence has been grabbed by several widgets, when the `key` sequence occurs a `QEvent::Shortcut` event is sent to all the widgets to which it applies in a non-deterministic order, but with the ``ambiguous'' flag set to true.

  Warning: You should not normally need to use this function; instead create `QAction`s with the shortcut key sequences you require (if you also want equivalent menu options and toolbar buttons), or create `QShortcut`s if you just need key sequences. Both `QAction` and `QShortcut` handle all the event filtering for you, and provide signals which are triggered when the user triggers the key sequence, so are much easier to use than this low-level function.

See also:
  `releaseShortcut()`, and `setShortcutEnabled()`.

### grabShortcut

    public final int grabShortcut(QKeySequence key,
                                  Qt.ShortcutContext context)

  Adds a shortcut to Qt's shortcut system that watches for the given `key` sequence in the given `context`. If the `context` is `Qt::ApplicationShortcut` , the shortcut applies to the application as a whole. Otherwise, it is either local to this widget, `Qt::WidgetShortcut` , or to the window itself, `Qt::WindowShortcut` .

  If the same `key` sequence has been grabbed by several widgets, when the `key` sequence occurs a `QEvent::Shortcut` event is sent to all the widgets to which it applies in a non-deterministic order, but with the ``ambiguous'' flag set to true.

  Warning: You should not normally need to use this function; instead create `QAction`s with the shortcut key sequences you require (if you also want equivalent menu options and toolbar buttons), or create `QShortcut`s if you just need key sequences. Both `QAction` and `QShortcut` handle all the event filtering for you, and provide signals which are triggered when the user triggers the key sequence, so are much easier to use than this low-level function.

See also:
  `releaseShortcut()`, and `setShortcutEnabled()`.

### hasFocus

    public final boolean hasFocus()

  This property holds whether this widget (or its focus proxy) has the keyboard input focus. By default, this property is false.

  Note: Obtaining the value of this property for a widget is effectively equivalent to checking whether `QApplication::focusWidget()` refers to the widget.

See also:
  `setFocus()`, `clearFocus()`, `setFocusPolicy()`, and `QApplication::focusWidget()`.

### hasMouseTracking

    public final boolean hasMouseTracking()

  This property holds whether mouse tracking is enabled for the widget. If mouse tracking is disabled (the default), the widget only receives mouse move events when at least one mouse button is pressed while the mouse is being moved.

  If mouse tracking is enabled, the widget receives mouse move events even if no buttons are pressed.

See also:
  `mouseMoveEvent()`.

### height

    public final int height()

  Returns the height of the paint device in default coordinate system units (e. . pixels for `QPixmap` and `QWidget`).

See also:
  `heightMM()`.

  Specified by:
    `height` in interface `QPaintDeviceInterface`

### heightMM

    public final int heightMM()

  Returns the height of the paint device in millimeters.

See also:
  `height()`.

  Specified by:
    `heightMM` in interface `QPaintDeviceInterface`

### hide

    public final void hide()

  Hides the widget. This function is equivalent to setVisible(false).

  Note: If you are working with `QDialog` or its subclasses and you invoke the `show()` function after this function, the dialog will be displayed in its original position.

See also:
  `hideEvent()`, `isHidden()`, `show()`, `setVisible()`, `isVisible()`, and `close()`.

### inputContext

    public final QInputContext inputContext()

  This function returns the `QInputContext` for this widget. By default the input context is inherited from the widgets parent. For toplevels it is inherited from `QApplication`.

  You can override this and set a special input context for this widget by using the `setInputContext()` method.

See also:
  `setInputContext()`.

### insertAction

    public final void insertAction(QAction before,
                                   QAction action)

  Inserts the action `action` to this widget's list of actions, before the action `before`. It appends the action if `before` is 0 or `before` is not a valid action for this widget.

  A `QWidget` should only have one of each action.

See also:
  `removeAction()`, `addAction()`, `QMenu`, `contextMenuPolicy`, and `actions()`.

### insertActions

    public final void insertActions(QAction before,
                                    java.util.List actions)

  Inserts the actions `actions` to this widget's list of actions, before the action `before`. It appends the action if `before` is 0 or `before` is not a valid action for this widget.

  A `QWidget` can have at most one of each action.

See also:
  `removeAction()`, `QMenu`, `insertAction()`, and `contextMenuPolicy`.

### isActiveWindow

    public final boolean isActiveWindow()

  This property holds whether this widget's window is the active window. The active window is the window that contains the widget that has keyboard focus (The window may still have focus if it has no widgets or none of its widgets accepts keyboard focus).

  When popup windows are visible, this property is true for both the active window and for the popup.

  By default, this property is false.

See also:
  `activateWindow()`, and `QApplication::activeWindow()`.

### isAncestorOf

    public final boolean isAncestorOf(QWidget child)

  Returns true if this widget is a parent, (or grandparent and so on to any level), of the given `child`, and both widgets are within the same window; otherwise returns false.

### isEnabled

    public final boolean isEnabled()

  This property holds whether the widget is enabled. An enabled widget handles keyboard and mouse events; a disabled widget does not.

  Some widgets display themselves differently when they are disabled. For example a button might draw its label grayed out. If your widget needs to know when it becomes enabled or disabled, you can use the `changeEvent()` with type `QEvent::EnabledChange` .

  Disabling a widget implicitly disables all its children. Enabling respectively enables all child widgets unless they have been explicitly disabled.

  By default, this property is true.

See also:
  `isEnabledTo()`, `QKeyEvent`, `QMouseEvent`, and `changeEvent()`.

### isEnabledTo

    public final boolean isEnabledTo(QWidget arg__1)

  Returns true if this widget would become enabled if `ancestor` is enabled; otherwise returns false.

  This is the case if neither the widget itself nor every parent up to but excluding `ancestor` has been explicitly disabled.

  isEnabledTo(0) is equivalent to `isEnabled()`.

See also:
  `setEnabled()`, and `enabled`.

### isFullScreen

    public final boolean isFullScreen()

  This property holds whether the widget is shown in full screen mode. A widget in full screen mode occupies the whole screen area and does not display window decorations, such as a title bar.

  By default, this property is false.

See also:
  `windowState()`, `minimized`, and `maximized`.

### isHidden

    public final boolean isHidden()

  Returns true if the widget is hidden, otherwise returns false.

  A hidden widget will only become visible when `show()` is called on it. It will not be automatically shown when the parent is shown.

  To check visiblity, use !`isVisible()` instead (notice the exclamation mark).

  `isHidden()` implies !`isVisible()`, but a widget can be not visible and not hidden at the same time. This is the case for widgets that are children of widgets that are not visible.

  Widgets are hidden if they were created as independent windows or as children of visible widgets, or if `hide()` or setVisible(false) was called.

### isMaximized

    public final boolean isMaximized()

  This property holds whether this widget is maximized. This property is only relevant for windows.

  Note: Due to limitations on some window systems, this does not always report the expected results (e.g., if the user on X11 maximizes the window via the window manager, Qt has no way of distinguishing this from any other resize). This is expected to improve as window manager protocols evolve.

  By default, this property is false.

See also:
  `windowState()`, `showMaximized()`, `visible`, `show()`, `hide()`, `showNormal()`, and `minimized`.

### isMinimized

    public final boolean isMinimized()

  This property holds whether this widget is minimized (iconified). This property is only relevant for windows.

  By default, this property is false.

See also:
  `showMinimized()`, `visible`, `show()`, `hide()`, `showNormal()`, and `maximized`.

### isModal

    public final boolean isModal()

  This property holds whether the widget is a modal widget. This property only makes sense for windows. A modal widget prevents widgets in all other windows from getting any input.

  By default, this property is false.

See also:
  `isWindow()`, `windowModality`, and `QDialog`.

### isVisible

    public final boolean isVisible()

  This property holds whether the widget is visible. Calling setVisible(true) or `show()` sets the widget to visible status if all its parent widgets up to the window are visible. If an ancestor is not visible, the widget won't become visible until all its ancestors are shown. If its size or position has changed, Qt guarantees that a widget gets move and resize events just before it is shown. If the widget has not been resized yet, Qt will adjust the widget's size to a useful default using `adjustSize()`.

  Calling setVisible(false) or `hide()` hides a widget explicitly. An explicitly hidden widget will never become visible, even if all its ancestors become visible, unless you show it.

  A widget receives show and hide events when its visibility status changes. Between a hide and a show event, there is no need to waste CPU cycles preparing or displaying information to the user. A video application, for example, might simply stop generating new frames.

  A widget that happens to be obscured by other windows on the screen is considered to be visible. The same applies to iconified windows and windows that exist on another virtual desktop (on platforms that support this concept). A widget receives spontaneous show and hide events when its mapping status is changed by the window system, e.g. a spontaneous hide event when the user minimizes the window, and a spontaneous show event when the window is restored again.

  You almost never have to reimplement the `setVisible()` function. If you need to change some settings before a widget is shown, use `showEvent()` instead. If you need to do some delayed initialization use the Polish event delivered to the `event()` function.

See also:
  `show()`, `hide()`, `isHidden()`, `isVisibleTo()`, `isMinimized()`, `showEvent()`, and `hideEvent()`.

### isVisibleTo

    public final boolean isVisibleTo(QWidget arg__1)

  Returns true if this widget would become visible if `ancestor` is shown; otherwise returns false.

  The true case occurs if neither the widget itself nor any parent up to but excluding `ancestor` has been explicitly hidden.

  This function will still return true if the widget is obscured by other windows on the screen, but could be physically visible if it or they were to be moved.

  isVisibleTo(0) is identical to `isVisible()`.

See also:
  `show()`, `hide()`, and `isVisible()`.

### isWindow

    public final boolean isWindow()

  Returns true if the widget is an independent window, otherwise returns false.

  A window is a widget that isn't visually the child of any other widget and that usually has a frame and a `window title`.

  A window can have a `parent widget`. It will then be grouped with its parent and deleted when the parent is deleted, minimized when the parent is minimized etc. If supported by the window manager, it will also have a common taskbar entry with its parent.

  `QDialog` and `QMainWindow` widgets are by default windows, even if a parent widget is specified in the constructor. This behavior is specified by the `Qt::Window` flag.

See also:
  `window()`, `isModal()`, and `parentWidget()`.

### isWindowModified

    public final boolean isWindowModified()

  This property holds whether the document shown in the window has unsaved changes. A modified window is a window whose content has changed but has not been saved to disk. This flag will have different effects varied by the platform. On Mac OS X the close button will have a modified look; on other platforms, the window title will have an '*' (asterisk).

  The window title must contain a "[*]" placeholder, which indicates where the '*' should appear. Normally, it should appear right after the file name (e.g., "document1.txt[*] - Text Editor"). If the window isn't modified, the placeholder is simply removed.

  Note that if a widget is set as modified, all its ancestors will also be set as modified. However, if you call `setWindowModified(false)` on a widget, this will not propagate to its parent because other children of the parent might have been modified.

See also:
  `windowTitle`, Application Example, SDI Example, and MDI Example.

### layout

    public final QLayout layout()

  Returns the layout manager that is installed on this widget, or 0 if no layout manager is installed.

  The layout manager sets the geometry of the widget's children that have been added to the layout.

See also:
  `setLayout()`, `sizePolicy()`, and Layout Classes.

### layoutDirection

    public final Qt.LayoutDirection layoutDirection()

  This property holds the layout direction for this widget. By default, this property is set to `Qt::LeftToRight` .

See also:
  `QApplication::layoutDirection`.

### locale

    public final QLocale locale()

  This property holds the widget's locale. As long as no special locale has been set, this is either the parent's locale or (if this widget is a top level widget), the default locale.

  If the widget displays dates or numbers, these should be formatted using the widget's locale.

See also:
  `QLocale`, and `QLocale::setDefault()`.

### logicalDpiX

    public final int logicalDpiX()

  Returns the horizontal resolution of the device in dots per inch, which is used when computing font sizes. For X11, this is usually the same as could be computed from `widthMM()`.

  Note that if the `logicalDpiX()` doesn't equal the `physicalDpiX()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `logicalDpiY()`, and `physicalDpiX()`.

  Specified by:
    `logicalDpiX` in interface `QPaintDeviceInterface`

### logicalDpiY

    public final int logicalDpiY()

  Returns the vertical resolution of the device in dots per inch, which is used when computing font sizes. For X11, this is usually the same as could be computed from `heightMM()`.

  Note that if the `logicalDpiY()` doesn't equal the `physicalDpiY()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `logicalDpiX()`, and `physicalDpiY()`.

  Specified by:
    `logicalDpiY` in interface `QPaintDeviceInterface`

### lower

    public final void lower()

  Lowers the widget to the bottom of the parent widget's stack.

  After this call the widget will be visually behind (and therefore obscured by) any overlapping sibling widgets.

See also:
  `raise()`, and `stackUnder()`.

### mapFrom

    public final QPoint mapFrom(QWidget arg__1,
                                QPoint arg__2)

  Translates the widget coordinate `pos` from the coordinate system of `parent` to this widget's coordinate system. The `parent` must not be 0 and must be a parent of the calling widget.

See also:
  `mapTo()`, `mapFromParent()`, `mapFromGlobal()`, and `underMouse()`.

### mapFromGlobal

    public final QPoint mapFromGlobal(QPoint arg__1)

  Translates the global screen coordinate `pos` to widget coordinates.

See also:
  `mapToGlobal()`, `mapFrom()`, and `mapFromParent()`.

### mapFromParent

    public final QPoint mapFromParent(QPoint arg__1)

  Translates the parent widget coordinate `pos` to widget coordinates.

  Same as `mapFromGlobal()` if the widget has no parent.

See also:
  `mapToParent()`, `mapFrom()`, `mapFromGlobal()`, and `underMouse()`.

### mapTo

    public final QPoint mapTo(QWidget arg__1,
                              QPoint arg__2)

  Translates the widget coordinate `pos` to the coordinate system of `parent`. The `parent` must not be 0 and must be a parent of the calling widget.

See also:
  `mapFrom()`, `mapToParent()`, `mapToGlobal()`, and `underMouse()`.

### mapToGlobal

    public final QPoint mapToGlobal(QPoint arg__1)

  Translates the widget coordinate `pos` to global screen coordinates. For example, `mapToGlobal(QPoint(0,0))` would give the global coordinates of the top-left pixel of the widget.

See also:
  `mapFromGlobal()`, `mapTo()`, and `mapToParent()`.

### mapToParent

    public final QPoint mapToParent(QPoint arg__1)

  Translates the widget coordinate `pos` to a coordinate in the parent widget.

  Same as `mapToGlobal()` if the widget has no parent.

See also:
  `mapFromParent()`, `mapTo()`, `mapToGlobal()`, and `underMouse()`.

### mask

    public final QRegion mask()

  Returns the mask currently set on a widget. If no mask is set the return value will be an empty region.

See also:
  `setMask()`, `clearMask()`, `QRegion::isEmpty()`, and Shaped Clock Example.

### maximumHeight

    public final int maximumHeight()

  This property holds the widget's maximum height in pixels. This property corresponds to the height held by the `maximumSize` property.

  By default, this property contains a value of 16777215.

  Note: The definition of the `QWIDGETSIZE_MAX` macro limits the maximum size of widgets.

See also:
  `maximumSize`, and `maximumWidth`.

### maximumSize

    public final QSize maximumSize()

  This property holds the widget's maximum size in pixels. The widget cannot be resized to a larger size than the maximum widget size.

  By default, this property contains a size in which both width and height have values of 16777215.

  Note: The definition of the `QWIDGETSIZE_MAX` macro limits the maximum size of widgets.

See also:
  `maximumWidth`, `maximumHeight`, `minimumSize`, and `sizeIncrement`.

### maximumWidth

    public final int maximumWidth()

  This property holds the widget's maximum width in pixels. This property corresponds to the width held by the `maximumSize` property.

  By default, this property contains a value of 16777215.

  Note: The definition of the `QWIDGETSIZE_MAX` macro limits the maximum size of widgets.

See also:
  `maximumSize`, and `maximumHeight`.

### minimumHeight

    public final int minimumHeight()

  This property holds the widget's minimum height in pixels. This property corresponds to the height held by the `minimumSize` property.

  By default, this property has a value of 0.

See also:
  `minimumSize`, and `minimumWidth`.

### minimumSize

    public final QSize minimumSize()

  This property holds the widget's minimum size. The widget cannot be resized to a smaller size than the minimum widget size. The widget's size is forced to the minimum size if the current size is smaller.

  The minimum size set by this function will override the minimum size defined by `QLayout`. In order to unset the minimum size, use a value of `QSize(0, 0)`.

  By default, this property contains a size with zero width and height.

See also:
  `minimumWidth`, `minimumHeight`, `maximumSize`, and `sizeIncrement`.

### minimumWidth

    public final int minimumWidth()

  This property holds the widget's minimum width in pixels. This property corresponds to the width held by the `minimumSize` property.

  By default, this property has a value of 0.

See also:
  `minimumSize`, and `minimumHeight`.

### move

    public final void move(QPoint arg__1)

  This property holds the position of the widget within its parent widget. If the widget is a window, the position is that of the widget on the desktop, including its frame.

  When changing the position, the widget, if visible, receives a move event (`moveEvent()`) immediately. If the widget is not currently visible, it is guaranteed to receive an event before it is shown.

  By default, this property contains a position that refers to the origin.

  Warning: Calling `move()` or `setGeometry()` inside `moveEvent()` can lead to infinite recursion.

  See the Window Geometry documentation for an overview of window geometry.

See also:
  `frameGeometry`, `size`, `x()`, and `y()`.

### move

    public final void move(int x,
                           int y)

  This property holds the position of the widget within its parent widget. If the widget is a window, the position is that of the widget on the desktop, including its frame.

  When changing the position, the widget, if visible, receives a move event (`moveEvent()`) immediately. If the widget is not currently visible, it is guaranteed to receive an event before it is shown.

  By default, this property contains a position that refers to the origin.

  Warning: Calling `move()` or `setGeometry()` inside `moveEvent()` can lead to infinite recursion.

  See the Window Geometry documentation for an overview of window geometry.

See also:
  `frameGeometry`, `size`, `x()`, and `y()`.

### nativeParentWidget

    public final QWidget nativeParentWidget()

  Returns the native parent for this widget, i. . the next ancestor widget that has a system identifier, or 0 if it does not have any native parent.

See also:
  `effectiveWinId()`.

### nextInFocusChain

    public final QWidget nextInFocusChain()

  Returns the next widget in this widget's focus chain.

### normalGeometry

    public final QRect normalGeometry()

  This property holds the geometry of the widget as it will appear when shown as a normal (not maximized or full screen) top-level widget. For child widgets this property always holds an empty rectangle.

  By default, this property contains an empty rectangle.

See also:
  `QWidget::windowState()`, and `QWidget::geometry`.

### numColors

    public final int numColors()

  Returns the number of different colors available for the paint device. Since this value is an int, it will not be sufficient to represent the number of colors on 32 bit displays, in this case INT_MAX is returned instead.

  Specified by:
    `numColors` in interface `QPaintDeviceInterface`

### overrideWindowFlags

    public final void overrideWindowFlags(Qt.WindowType[] type)

  Sets the window flags for the widget to `flags`, without telling the window system.

  Warning: Do not call this function unless you really know what you're doing.

See also:
  `setWindowFlags()`.

### overrideWindowFlags

    public final void overrideWindowFlags(Qt.WindowFlags type)

  Sets the window flags for the widget to `flags`, without telling the window system.

  Warning: Do not call this function unless you really know what you're doing.

See also:
  `setWindowFlags()`.

### paintingActive

    public final boolean paintingActive()

  Returns true if the device is currently being painted on, i. . someone has called `QPainter::begin()` but not yet called `QPainter::end()` for this device; otherwise returns false.

See also:
  `QPainter::isActive()`.

  Specified by:
    `paintingActive` in interface `QPaintDeviceInterface`

### palette

    public final QPalette palette()

  This property holds the widget's palette. As long as no special palette has been set, this is either a special palette for the widget class, the parent's palette, or (if this widget is a top level widget), the default application palette.

  The palette's background color will only have an effect on the appearance of the widget if the `autoFillBackground` property is set.

  There are two types of styles in Qt:

  - A color based one used to indicate the background, foreground, etc., and
  - A pixmap based one which usually relies on a theming engine on the underlying platform.
  Changing this property on a widget with a pixmap based style will usually not result in a visual change on that widget. Refer to our Knowledge Base article here for more information.

  Warning: Do not use this function in conjunction with Qt Style Sheets. When using style sheets, the palette of a widget can be customized using the "color", "background-color", "selection-color", "selection-background-color" and "alternate-background-color".

See also:
  `QApplication::palette()`.

### parentWidget

    public final QWidget parentWidget()

  Returns the parent of this widget, or 0 if it does not have any parent widget.

### physicalDpiX

    public final int physicalDpiX()

  Returns the horizontal resolution of the device in dots per inch. For example, when printing, this resolution refers to the physical printer's resolution. The logical DPI on the other hand, refers to the resolution used by the actual paint engine.

  Note that if the `physicalDpiX()` doesn't equal the `logicalDpiX()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `physicalDpiY()`, and `logicalDpiX()`.

  Specified by:
    `physicalDpiX` in interface `QPaintDeviceInterface`

### physicalDpiY

    public final int physicalDpiY()

  Returns the horizontal resolution of the device in dots per inch. For example, when printing, this resolution refers to the physical printer's resolution. The logical DPI on the other hand, refers to the resolution used by the actual paint engine.

  Note that if the `physicalDpiY()` doesn't equal the `logicalDpiY()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `physicalDpiX()`, and `logicalDpiY()`.

  Specified by:
    `physicalDpiY` in interface `QPaintDeviceInterface`

### pos

    public final QPoint pos()

  This property holds the position of the widget within its parent widget. If the widget is a window, the position is that of the widget on the desktop, including its frame.

  When changing the position, the widget, if visible, receives a move event (`moveEvent()`) immediately. If the widget is not currently visible, it is guaranteed to receive an event before it is shown.

  By default, this property contains a position that refers to the origin.

  Warning: Calling `move()` or `setGeometry()` inside `moveEvent()` can lead to infinite recursion.

  See the Window Geometry documentation for an overview of window geometry.

See also:
  `frameGeometry`, `size`, `x()`, and `y()`.

### raise

    public final void raise()

  Raises this widget to the top of the parent widget's stack.

  After this call the widget will be visually in front of any overlapping sibling widgets.

  Note: When using `activateWindow()`, you can call this function to ensure that the window is stacked on top.

See also:
  `lower()`, and `stackUnder()`.

### rect

    public final QRect rect()

  This property holds the internal geometry of the widget excluding any window frame. The rect property equals `QRect`(0, 0, `width()`, `height()`).

  See the Window Geometry documentation for an overview of window geometry.

  By default, this property contains a value that depends on the user's platform and screen geometry.

See also:
  `size`.

### releaseKeyboard

    public final void releaseKeyboard()

  Releases the keyboard grab.

See also:
  `grabKeyboard()`, `grabMouse()`, and `releaseMouse()`.

### releaseMouse

    public final void releaseMouse()

  Releases the mouse grab.

See also:
  `grabMouse()`, `grabKeyboard()`, and `releaseKeyboard()`.

### releaseShortcut

    public final void releaseShortcut(int id)

  Removes the shortcut with the given `id` from Qt's shortcut system. The widget will no longer receive `QEvent::Shortcut` events for the shortcut's key sequence (unless it has other shortcuts with the same key sequence).

  Warning: You should not normally need to use this function since Qt's shortcut system removes shortcuts automatically when their parent widget is destroyed. It is best to use `QAction` or `QShortcut` to handle shortcuts, since they are easier to use than this low-level function. Note also that this is an expensive operation.

See also:
  `grabShortcut()`, and `setShortcutEnabled()`.

### removeAction

    public final void removeAction(QAction action)

  Removes the action `action` from this widget's list of actions.

See also:
  `insertAction()`, `actions()`, and `insertAction()`.

### render

    public final void render(QPaintDeviceInterface target,
                             QPoint targetOffset,
                             QRegion sourceRegion,
                             QWidget.RenderFlag[] renderFlags)

  Renders the `sourceRegion` of this widget into the `target` using `renderFlags` to determine how to render. Rendering starts at `targetOffset` in the `target`. For example:

              QPixmap pixmap = new QPixmap(widget.size());
              widget.render(pixmap);

  If `sourceRegion` is a null region, this function will use `QWidget::rect()` as the region, i.e. the entire widget.

  Note: Make sure to call `QPainter::end()` for the given `target`'s active painter (if any) before rendering. For example:

              QPainter painter = new QPainter(this);
              //...
              painter.end();
              myWidget.render(this);

### render

    public final void render(QPaintDeviceInterface target,
                             QPoint targetOffset,
                             QRegion sourceRegion)

  Renders the `sourceRegion` of this widget into the `target` using `renderFlags` to determine how to render. Rendering starts at `targetOffset` in the `target`. For example:

              QPixmap pixmap = new QPixmap(widget.size());
              widget.render(pixmap);

  If `sourceRegion` is a null region, this function will use `QWidget::rect()` as the region, i.e. the entire widget.

  Note: Make sure to call `QPainter::end()` for the given `target`'s active painter (if any) before rendering. For example:

              QPainter painter = new QPainter(this);
              //...
              painter.end();
              myWidget.render(this);

### render

    public final void render(QPaintDeviceInterface target,
                             QPoint targetOffset)

  Renders the `sourceRegion` of this widget into the `target` using `renderFlags` to determine how to render. Rendering starts at `targetOffset` in the `target`. For example:

              QPixmap pixmap = new QPixmap(widget.size());
              widget.render(pixmap);

  If `sourceRegion` is a null region, this function will use `QWidget::rect()` as the region, i.e. the entire widget.

  Note: Make sure to call `QPainter::end()` for the given `target`'s active painter (if any) before rendering. For example:

              QPainter painter = new QPainter(this);
              //...
              painter.end();
              myWidget.render(this);

### render

    public final void render(QPaintDeviceInterface target)

  Renders the `sourceRegion` of this widget into the `target` using `renderFlags` to determine how to render. Rendering starts at `targetOffset` in the `target`. For example:

              QPixmap pixmap = new QPixmap(widget.size());
              widget.render(pixmap);

  If `sourceRegion` is a null region, this function will use `QWidget::rect()` as the region, i.e. the entire widget.

  Note: Make sure to call `QPainter::end()` for the given `target`'s active painter (if any) before rendering. For example:

              QPainter painter = new QPainter(this);
              //...
              painter.end();
              myWidget.render(this);

### render

    public final void render(QPaintDeviceInterface target,
                             QPoint targetOffset,
                             QRegion sourceRegion,
                             QWidget.RenderFlags renderFlags)

  Renders the `sourceRegion` of this widget into the `target` using `renderFlags` to determine how to render. Rendering starts at `targetOffset` in the `target`. For example:

              QPixmap pixmap = new QPixmap(widget.size());
              widget.render(pixmap);

  If `sourceRegion` is a null region, this function will use `QWidget::rect()` as the region, i.e. the entire widget.

  Note: Make sure to call `QPainter::end()` for the given `target`'s active painter (if any) before rendering. For example:

              QPainter painter = new QPainter(this);
              //...
              painter.end();
              myWidget.render(this);

### render

    public final void render(QPainter painter,
                             QPoint targetOffset,
                             QRegion sourceRegion,
                             QWidget.RenderFlag[] renderFlags)

  Renders the widget into the `painter`'s `QPainter::device()`.

  Transformations and settings applied to the `painter` will be used when rendering.

  Note: The `painter` must be active. On Mac OS X the widget will be rendered into a `QPixmap` and then drawn by the `painter`.

See also:
  `QPainter::device()`.

### render

    public final void render(QPainter painter,
                             QPoint targetOffset,
                             QRegion sourceRegion)

  Renders the widget into the `painter`'s `QPainter::device()`.

  Transformations and settings applied to the `painter` will be used when rendering.

  Note: The `painter` must be active. On Mac OS X the widget will be rendered into a `QPixmap` and then drawn by the `painter`.

See also:
  `QPainter::device()`.

### render

    public final void render(QPainter painter,
                             QPoint targetOffset)

  Renders the widget into the `painter`'s `QPainter::device()`.

  Transformations and settings applied to the `painter` will be used when rendering.

  Note: The `painter` must be active. On Mac OS X the widget will be rendered into a `QPixmap` and then drawn by the `painter`.

See also:
  `QPainter::device()`.

### render

    public final void render(QPainter painter,
                             QPoint targetOffset,
                             QRegion sourceRegion,
                             QWidget.RenderFlags renderFlags)

  Renders the widget into the `painter`'s `QPainter::device()`.

  Transformations and settings applied to the `painter` will be used when rendering.

  Note: The `painter` must be active. On Mac OS X the widget will be rendered into a `QPixmap` and then drawn by the `painter`.

See also:
  `QPainter::device()`.

### repaint

    public final void repaint()

  Repaints the widget directly by calling `paintEvent()` immediately, unless updates are disabled or the widget is hidden.

  We suggest only using `repaint()` if you need an immediate repaint, for example during animation. In almost all circumstances `update()` is better, as it permits Qt to optimize for speed and minimize flicker.

  Warning: If you call `repaint()` in a function which may itself be called from `paintEvent()`, you may get infinite recursion. The `update()` function never causes recursion.

See also:
  `update()`, `paintEvent()`, and `setUpdatesEnabled()`.

### repaint

    public final void repaint(QRect arg__1)

  This version repaints a rectangle `r` inside the widget.

### repaint

    public final void repaint(QRegion arg__1)

  This version repaints a region `rgn` inside the widget.

### repaint

    public final void repaint(int x,
                              int y,
                              int w,
                              int h)

  This version repaints a rectangle (`x`, `y`, `w`, `h`) inside the widget.

  If `w` is negative, it is replaced with `width() - x`, and if `h` is negative, it is replaced width `height() - y`.

### resetInputContext

    protected final void resetInputContext()

  This function can be called on the widget that currently has focus to reset the input method operating on it.

See also:
  `QInputContext`, and `QInputContext::reset()`.

### resize

    public final void resize(QSize arg__1)

  This property holds the size of the widget excluding any window frame. If the widget is visible when it is being resized, it receives a resize event (`resizeEvent()`) immediately. If the widget is not currently visible, it is guaranteed to receive an event before it is shown.

  The size is adjusted if it lies outside the range defined by `minimumSize()` and `maximumSize()`.

  By default, this property contains a value that depends on the user's platform and screen geometry.

  Warning: Calling `resize()` or `setGeometry()` inside `resizeEvent()` can lead to infinite recursion.

  Note: Setting the size to `QSize(0, 0)` will cause the widget to not appear on screen. This also applies to windows.

See also:
  `pos`, `geometry`, `minimumSize`, `maximumSize`, and `resizeEvent()`.

### resize

    public final void resize(int w,
                             int h)

  This property holds the size of the widget excluding any window frame. If the widget is visible when it is being resized, it receives a resize event (`resizeEvent()`) immediately. If the widget is not currently visible, it is guaranteed to receive an event before it is shown.

  The size is adjusted if it lies outside the range defined by `minimumSize()` and `maximumSize()`.

  By default, this property contains a value that depends on the user's platform and screen geometry.

  Warning: Calling `resize()` or `setGeometry()` inside `resizeEvent()` can lead to infinite recursion.

  Note: Setting the size to `QSize(0, 0)` will cause the widget to not appear on screen. This also applies to windows.

See also:
  `pos`, `geometry`, `minimumSize`, `maximumSize`, and `resizeEvent()`.

### restoreGeometry

    public final boolean restoreGeometry(QByteArray geometry)

  Restores the geometry and state top-level widgets stored in the byte array `geometry`. Returns true on success; otherwise returns false.

  If the restored geometry is off-screen, it will be modified to be inside the the available screen geometry.

  To restore geometry saved using `QSettings`, you can use code like this:

              QSettings settings = new QSettings("MyCompany", "MyApp");
              myWidget.restoreGeometry((QByteArray) settings.value("myWidget/geometry"));

  See the Window Geometry documentation for an overview of geometry issues with windows.

See also:
  `saveGeometry()`, and `QSettings`.

### saveGeometry

    public final QByteArray saveGeometry()

  Saves the current geometry and state for top-level widgets.

  To save the geometry when the window closes, you can implement a close event like this:

          protected void closeEvent(QCloseEvent event)
          {
              QSettings settings = new QSettings("MyCompany", "MyApp");
              settings.setValue("geometry", saveGeometry());
              super.closeEvent(event);
          }

  See the Window Geometry documentation for an overview of geometry issues with windows.

See also:
  `restoreGeometry()`.

### scroll

    public final void scroll(int dx,
                             int dy)

  Scrolls the widget including its children `dx` pixels to the right and `dy` downward. Both `dx` and `dy` may be negative.

  After scrolling, the widgets will receive paint events for the areas that need to be repainted. For widgets that Qt knows to be opaque, this is only the newly exposed parts. For example, if an opaque widget is scrolled 8 pixels to the left, only an 8-pixel wide stripe at the right edge needs updating.

  Since widgets propagate the contents of their parents by default, you need to set the `autoFillBackground` property, or use `setAttribute()` to set the `Qt::WA_OpaquePaintEvent` attribute, to make a widget opaque.

  For widgets that use contents propagation, a scroll will cause an update of the entire scroll area.

See also:
  `Transparency and Double Buffering`.

### scroll

    public final void scroll(int dx,
                             int dy,
                             QRect arg__3)

  This version only scrolls `r` and does not move the children of the widget.

  If `r` is empty or invalid, the result is undefined.

See also:
  `QScrollArea`.

### setAcceptDrops

    public final void setAcceptDrops(boolean on)

  This property holds whether drop events are enabled for this widget. Setting this property to true announces to the system that this widget may be able to accept drop events.

  If the widget is the desktop (`windowType()` == `Qt::Desktop` ), this may fail if another application is using the desktop; you can call `acceptDrops()` to test if this occurs.

  Warning: Do not modify this property in a drag and drop event handler.

  By default, this property is false.

See also:
  Drag and Drop.

### setAccessibleDescription

    public final void setAccessibleDescription(java.lang.String description)

  This property holds the widget's description as seen by assistive technologies. By default, this property contains an empty string.

See also:
  `QAccessibleInterface::text()`.

### setAccessibleName

    public final void setAccessibleName(java.lang.String name)

  This property holds the widget's name as seen by assistive technologies. This property is used by accessible clients to identify, find, or announce the widget for accessible clients.

  By default, this property contains an empty string.

See also:
  `QAccessibleInterface::text()`.

### setAttribute

    public final void setAttribute(Qt.WidgetAttribute arg__1)

  Sets the attribute `attribute` on this widget if `on` is true; otherwise clears the attribute.

See also:
  `testAttribute()`.

### setAttribute

    public final void setAttribute(Qt.WidgetAttribute arg__1,
                                   boolean on)

  Sets the attribute `attribute` on this widget if `on` is true; otherwise clears the attribute.

See also:
  `testAttribute()`.

### setAutoFillBackground

    public final void setAutoFillBackground(boolean enabled)

  This property holds whether the widget background is filled automatically. If enabled, this will cause Qt to fill the background of the widget before invoking the paint event. The color used is defined by the `QPalette::Window` color role from the widget's `palette`.

  In addition, Windows are always filled with `QPalette::Window` , unless the WA_OpaquePaintEvent or WA_NoSystemBackground attributes are set.

  Warning: Use this property with caution in conjunction with Qt Style Sheets. When a widget has a style sheet with a valid background or a border-image, this property is automatically disabled.

  By default, this property is false.

See also:
  `Qt::WA_OpaquePaintEvent` , `Qt::WA_NoSystemBackground` , and `Transparency and Double Buffering`.

### setBackgroundRole

    public final void setBackgroundRole(QPalette.ColorRole arg__1)

  Sets the background role of the widget to `role`.

  The background role defines the brush from the widget's `palette` that is used to render the background.

  If `role` is `QPalette::NoRole` , then the widget inherits its parent's background role.

See also:
  `backgroundRole()`, and `foregroundRole()`.

### setBaseSize

    public final void setBaseSize(QSize arg__1)

  This property holds the base size of the widget. The base size is used to calculate a proper widget size if the widget defines `sizeIncrement()`.

  By default, for a newly-created widget, this property contains a size with zero width and height.

See also:
  `setSizeIncrement()`.

### setBaseSize

    public final void setBaseSize(int basew,
                                  int baseh)

  This property holds the base size of the widget. The base size is used to calculate a proper widget size if the widget defines `sizeIncrement()`.

  By default, for a newly-created widget, this property contains a size with zero width and height.

See also:
  `setSizeIncrement()`.

### setContentsMargins

    public final void setContentsMargins(int left,
                                         int top,
                                         int right,
                                         int bottom)

  Sets the margins around the contents of the widget to have the sizes `left`, `top`, `right`, and `bottom`. The margins are used by the layout system, and may be used by subclasses to specify the area to draw in (e.g. excluding the frame).

  Changing the margins will trigger a `resizeEvent()`.

See also:
  `contentsRect()`, and `getContentsMargins()`.

### setContextMenuPolicy

    public final void setContextMenuPolicy(Qt.ContextMenuPolicy policy)

  This property holds how the widget shows a context menu. The default value of this property is `Qt::DefaultContextMenu` , which means the `contextMenuEvent()` handler is called. Other values are `Qt::NoContextMenu` , `Qt::PreventContextMenu` , `Qt::ActionsContextMenu` , and `Qt::CustomContextMenu` . With `Qt::CustomContextMenu` , the signal `customContextMenuRequested()` is emitted.

See also:
  `contextMenuEvent()`, `customContextMenuRequested()` , and `actions()`.

### setCursor

    public final void setCursor(QCursor arg__1)

  This property holds the cursor shape for this widget. The mouse cursor will assume this shape when it's over this widget. See the `list of predefined cursor objects` for a range of useful shapes.

  An editor widget might use an I-beam cursor:

              w.setCursor(new QCursor(Qt.CursorShape.IBeamCursor));

  If no cursor has been set, or after a call to `unsetCursor()`, the parent's cursor is used.

  By default, this property contains a cursor with the `Qt::ArrowCursor` shape.

See also:
  `QApplication::setOverrideCursor()`.

### setDisabled

    public final void setDisabled(boolean arg__1)

  Disables widget input events if `disable` is true; otherwise enables input events.

  See the `enabled` documentation for more information.

See also:
  `isEnabledTo()`, `QKeyEvent`, `QMouseEvent`, and `changeEvent()`.

### setEnabled

    public final void setEnabled(boolean arg__1)

  This property holds whether the widget is enabled. An enabled widget handles keyboard and mouse events; a disabled widget does not.

  Some widgets display themselves differently when they are disabled. For example a button might draw its label grayed out. If your widget needs to know when it becomes enabled or disabled, you can use the `changeEvent()` with type `QEvent::EnabledChange` .

  Disabling a widget implicitly disables all its children. Enabling respectively enables all child widgets unless they have been explicitly disabled.

  By default, this property is true.

See also:
  `isEnabledTo()`, `QKeyEvent`, `QMouseEvent`, and `changeEvent()`.

### setFixedHeight

    public final void setFixedHeight(int h)

  Sets both the minimum and maximum heights of the widget to `h` without changing the widths. Provided for convenience.

See also:
  `sizeHint()`, `minimumSize()`, `maximumSize()`, and `setFixedSize()`.

### setFixedSize

    public final void setFixedSize(QSize arg__1)

  Sets both the minimum and maximum sizes of the widget to `s`, thereby preventing it from ever growing or shrinking.

  This will override the default size constraints set by `QLayout`.

  Alternatively, if you want the widget to have a fixed size based on its contents, you can call QLayout::setSizeConstraint(`QLayout::SetFixedSize` );

See also:
  `maximumSize`, and `minimumSize`.

### setFixedSize

    public final void setFixedSize(int w,
                                   int h)

  Sets the width of the widget to `w` and the height to `h`.

### setFixedWidth

    public final void setFixedWidth(int w)

  Sets both the minimum and maximum width of the widget to `w` without changing the heights. Provided for convenience.

See also:
  `sizeHint()`, `minimumSize()`, `maximumSize()`, and `setFixedSize()`.

### setFocus

    public final void setFocus()

  Gives the keyboard input focus to this widget (or its focus proxy) if this widget or one of its parents is the `active window`.

### setFocus

    public final void setFocus(Qt.FocusReason reason)

  Gives the keyboard input focus to this widget (or its focus proxy) if this widget or one of its parents is the `active window`. The `reason` argument will be passed into any focus event sent from this function, it is used to give an explanation of what caused the widget to get focus.

  First, a focus out event is sent to the focus widget (if any) to tell it that it is about to lose the focus. Then a focus in event is sent to this widget to tell it that it just received the focus. (Nothing happens if the focus in and focus out widgets are the same.)

  `setFocus()` gives focus to a widget regardless of its focus policy, but does not clear any keyboard grab (see `grabKeyboard()`).

  Be aware that if the widget is hidden, it will not accept focus until it is shown.

  Warning: If you call `setFocus()` in a function which may itself be called from `focusOutEvent()` or `focusInEvent()`, you may get an infinite recursion.

  `setFocusPolicy()``QApplication::focusWidget()``grabKeyboard()``grabMouse()`, {Keyboard Focus}

See also:
  `hasFocus()`, `clearFocus()`, `focusInEvent()`, and `focusOutEvent()`.

### setFocusPolicy

    public final void setFocusPolicy(Qt.FocusPolicy policy)

  This property holds the way the widget accepts keyboard focus. The policy is `Qt::TabFocus` if the widget accepts keyboard focus by tabbing, `Qt::ClickFocus` if the widget accepts focus by clicking, `Qt::StrongFocus` if it accepts both, and `Qt::NoFocus` (the default) if it does not accept focus at all.

  You must enable keyboard focus for a widget if it processes keyboard events. This is normally done from the widget's constructor. For instance, the `QLineEdit` constructor calls setFocusPolicy(`Qt::StrongFocus` ).

See also:
  `focusInEvent()`, `focusOutEvent()`, `keyPressEvent()`, `keyReleaseEvent()`, and `enabled`.

### setFocusProxy

    public final void setFocusProxy(QWidget arg__1)

  Sets the widget's focus proxy to widget `w`. If `w` is 0, the function resets this widget to have no focus proxy.

  Some widgets can "have focus", but create a child widget, such as `QLineEdit`, to actually handle the focus. In this case, the widget can set the line edit to be its focus proxy.

  `setFocusProxy()` sets the widget which will actually get focus when "this widget" gets it. If there is a focus proxy, `setFocus()` and `hasFocus()` operate on the focus proxy.

See also:
  `focusProxy()`.

### setFont

    public final void setFont(QFont arg__1)

  This property holds the font currently set for the widget. The `fontInfo()` function reports the actual font that is being used by the widget.

  As long as no special font has been set, or after setFont(QFont()) is called, this is either a special font for the widget class, the parent's font or (if this widget is a top level widget), the default application font.

  This code fragment sets a 12 point helvetica bold font:

              QFont fonti = new QFont("Helvetica", 12, QFont.Weight.Bold.value());
              w.setFont(font);

  Note that when a child widget is given a different font to that of its parent widget, it will still inherit the parent's font properties unless these have been set explicitly on the child's font. For example, if the parent's font is bold, the child widget's font will be bold as well if not specified otherwise like this:

              QFont font = new QFont();
              font.setBold(false);
              w.setFont(font);

  In addition to setting the font, `setFont()` informs all children about the change.

  Note: If Qt Style Sheets are used on the same widget as `setFont()`, style sheets will take precedence if the settings conflict.

See also:
  `fontInfo()`, and `fontMetrics()`.

### setForegroundRole

    public final void setForegroundRole(QPalette.ColorRole arg__1)

  Sets the foreground role of the widget to `role`.

  The foreground role defines the color from the widget's `palette` that is used to draw the foreground.

  If `role` is `QPalette::NoRole` , the widget uses a foreground role that contrasts with the background role.

See also:
  `foregroundRole()`, and `backgroundRole()`.

### setGeometry

    public final void setGeometry(QRect arg__1)

  This property holds the geometry of the widget relative to its parent and excluding the window frame. When changing the geometry, the widget, if visible, receives a move event (`moveEvent()`) and/or a resize event (`resizeEvent()`) immediately. If the widget is not currently visible, it is guaranteed to receive appropriate events before it is shown.

  The size component is adjusted if it lies outside the range defined by `minimumSize()` and `maximumSize()`.

  Warning: Calling `setGeometry()` inside `resizeEvent()` or `moveEvent()` can lead to infinite recursion.

  See the Window Geometry documentation for an overview of window geometry.

  By default, this property contains a value that depends on the user's platform and screen geometry.

See also:
  `frameGeometry()`, `rect()`, `move()`, `resize()`, `moveEvent()`, `resizeEvent()`, `minimumSize()`, and `maximumSize()`.

### setGeometry

    public final void setGeometry(int x,
                                  int y,
                                  int w,
                                  int h)

  This property holds the geometry of the widget relative to its parent and excluding the window frame. When changing the geometry, the widget, if visible, receives a move event (`moveEvent()`) and/or a resize event (`resizeEvent()`) immediately. If the widget is not currently visible, it is guaranteed to receive appropriate events before it is shown.

  The size component is adjusted if it lies outside the range defined by `minimumSize()` and `maximumSize()`.

  Warning: Calling `setGeometry()` inside `resizeEvent()` or `moveEvent()` can lead to infinite recursion.

  See the Window Geometry documentation for an overview of window geometry.

  By default, this property contains a value that depends on the user's platform and screen geometry.

See also:
  `frameGeometry()`, `rect()`, `move()`, `resize()`, `moveEvent()`, `resizeEvent()`, `minimumSize()`, and `maximumSize()`.

### setHidden

    public final void setHidden(boolean hidden)

  Convenience function, equivalent to setVisible(!`hidden`).

See also:
  `isHidden()`.

### setInputContext

    public final void setInputContext(QInputContext arg__1)

  This function sets the input context `context` on this widget.

See also:
  `inputContext()`.

### setLayout

    public final void setLayout(QLayout arg__1)

  Sets the layout manager for this widget to `layout`.

  If there already is a layout manager installed on this widget, `QWidget` won't let you install another. You must first delete the existing layout manager (returned by `layout()`) before you can call `setLayout()` with the new layout.

  Example:
  The following code example is written in c++.

          QVBoxLayout *layout = new QVBoxLayout;
          layout->addWidget(lcd);
          layout->addWidget(slider);
          setLayout(layout);

  An alternative to calling this function is to pass this widget to the layout's constructor.

  The `QWidget` will take ownership of `layout`.

See also:
  `layout()`, and Layout Classes.

### setLayoutDirection

    public final void setLayoutDirection(Qt.LayoutDirection direction)

  This property holds the layout direction for this widget. By default, this property is set to `Qt::LeftToRight` .

See also:
  `QApplication::layoutDirection`.

### setLocale

    public final void setLocale(QLocale locale)

  This property holds the widget's locale. As long as no special locale has been set, this is either the parent's locale or (if this widget is a top level widget), the default locale.

  If the widget displays dates or numbers, these should be formatted using the widget's locale.

See also:
  `QLocale`, and `QLocale::setDefault()`.

### setMask

    public final void setMask(QBitmap arg__1)

  Causes only the pixels of the widget for which `bitmap` has a corresponding 1 bit to be visible. If the region includes pixels outside the `rect()` of the widget, window system controls in that area may or may not be visible, depending on the platform.

  Note that this effect can be slow if the region is particularly complex.

  The following code shows how an image with an alpha channel can be used to generate a mask for a widget:

              QLabel topLevelLabel = new QLabel();
              QPixmap pixmap = new QPixmap("classpath:tux.png");
              topLevelLabel.setPixmap(pixmap);
              topLevelLabel.setMask(pixmap.mask());

  The label shown by this code is masked using the image it contains, giving the appearance that an irregularly-shaped image is being drawn directly onto the screen.

  Masked widgets receive mouse events only on their visible portions.

See also:
  `mask()`, `clearMask()`, `windowOpacity()`, and Shaped Clock Example.

### setMask

    public final void setMask(QRegion arg__1)

  Causes only the parts of the widget which overlap `region` to be visible. If the region includes pixels outside the `rect()` of the widget, window system controls in that area may or may not be visible, depending on the platform.

  Note that this effect can be slow if the region is particularly complex.

See also:
  `windowOpacity`.

### setMaximumHeight

    public final void setMaximumHeight(int maxh)

  This property holds the widget's maximum height in pixels. This property corresponds to the height held by the `maximumSize` property.

  By default, this property contains a value of 16777215.

  Note: The definition of the `QWIDGETSIZE_MAX` macro limits the maximum size of widgets.

See also:
  `maximumSize`, and `maximumWidth`.

### setMaximumSize

    public final void setMaximumSize(QSize arg__1)

  This property holds the widget's maximum size in pixels. The widget cannot be resized to a larger size than the maximum widget size.

  By default, this property contains a size in which both width and height have values of 16777215.

  Note: The definition of the `QWIDGETSIZE_MAX` macro limits the maximum size of widgets.

See also:
  `maximumWidth`, `maximumHeight`, `minimumSize`, and `sizeIncrement`.

### setMaximumSize

    public final void setMaximumSize(int maxw,
                                     int maxh)

  This property holds the widget's maximum size in pixels. The widget cannot be resized to a larger size than the maximum widget size.

  By default, this property contains a size in which both width and height have values of 16777215.

  Note: The definition of the `QWIDGETSIZE_MAX` macro limits the maximum size of widgets.

See also:
  `maximumWidth`, `maximumHeight`, `minimumSize`, and `sizeIncrement`.

### setMaximumWidth

    public final void setMaximumWidth(int maxw)

  This property holds the widget's maximum width in pixels. This property corresponds to the width held by the `maximumSize` property.

  By default, this property contains a value of 16777215.

  Note: The definition of the `QWIDGETSIZE_MAX` macro limits the maximum size of widgets.

See also:
  `maximumSize`, and `maximumHeight`.

### setMinimumHeight

    public final void setMinimumHeight(int minh)

  This property holds the widget's minimum height in pixels. This property corresponds to the height held by the `minimumSize` property.

  By default, this property has a value of 0.

See also:
  `minimumSize`, and `minimumWidth`.

### setMinimumSize

    public final void setMinimumSize(QSize arg__1)

  This property holds the widget's minimum size. The widget cannot be resized to a smaller size than the minimum widget size. The widget's size is forced to the minimum size if the current size is smaller.

  The minimum size set by this function will override the minimum size defined by `QLayout`. In order to unset the minimum size, use a value of `QSize(0, 0)`.

  By default, this property contains a size with zero width and height.

See also:
  `minimumWidth`, `minimumHeight`, `maximumSize`, and `sizeIncrement`.

### setMinimumSize

    public final void setMinimumSize(int minw,
                                     int minh)

  This property holds the widget's minimum size. The widget cannot be resized to a smaller size than the minimum widget size. The widget's size is forced to the minimum size if the current size is smaller.

  The minimum size set by this function will override the minimum size defined by `QLayout`. In order to unset the minimum size, use a value of `QSize(0, 0)`.

  By default, this property contains a size with zero width and height.

See also:
  `minimumWidth`, `minimumHeight`, `maximumSize`, and `sizeIncrement`.

### setMinimumWidth

    public final void setMinimumWidth(int minw)

  This property holds the widget's minimum width in pixels. This property corresponds to the width held by the `minimumSize` property.

  By default, this property has a value of 0.

See also:
  `minimumSize`, and `minimumHeight`.

### setMouseTracking

    public final void setMouseTracking(boolean enable)

  This property holds whether mouse tracking is enabled for the widget. If mouse tracking is disabled (the default), the widget only receives mouse move events when at least one mouse button is pressed while the mouse is being moved.

  If mouse tracking is enabled, the widget receives mouse move events even if no buttons are pressed.

See also:
  `mouseMoveEvent()`.

### setPalette

    public final void setPalette(QPalette arg__1)

  This property holds the widget's palette. As long as no special palette has been set, this is either a special palette for the widget class, the parent's palette, or (if this widget is a top level widget), the default application palette.

  The palette's background color will only have an effect on the appearance of the widget if the `autoFillBackground` property is set.

  There are two types of styles in Qt:

  - A color based one used to indicate the background, foreground, etc., and
  - A pixmap based one which usually relies on a theming engine on the underlying platform.
  Changing this property on a widget with a pixmap based style will usually not result in a visual change on that widget. Refer to our Knowledge Base article here for more information.

  Warning: Do not use this function in conjunction with Qt Style Sheets. When using style sheets, the palette of a widget can be customized using the "color", "background-color", "selection-color", "selection-background-color" and "alternate-background-color".

See also:
  `QApplication::palette()`.

### setParent

    public final void setParent(QWidget parent)

  Sets the parent of the widget to `parent`, and resets the window flags. The widget is moved to position (0, 0) in its new parent.

  If the new parent widget is in a different window, the reparented widget and its children are appended to the end of the `tab chain` of the new parent widget, in the same internal order as before. If one of the moved widgets had keyboard focus, `setParent()` calls `clearFocus()` for that widget.

  If the new parent widget is in the same window as the old parent, setting the parent doesn't change the tab order or keyboard focus.

  If the "new" parent widget is the old parent widget, this function does nothing.

  Note: The widget becomes invisible as part of changing its parent, even if it was previously visible. You must call `show()` to make the widget visible again.

  Warning: It is very unlikely that you will ever need this function. If you have a widget that changes its content dynamically, it is far easier to use `QStackedWidget`.

See also:
  `setWindowFlags()`.

### setParent

    public final void setParent(QWidget parent,
                                Qt.WindowType[] f)

  This function also takes widget flags, `f` as an argument.

### setParent

    public final void setParent(QWidget parent,
                                Qt.WindowFlags f)

  This function also takes widget flags, `f` as an argument.

### setShortcutAutoRepeat

    public final void setShortcutAutoRepeat(int id)

  If `enable` is true, auto repeat of the shortcut with the given `id` is enabled; otherwise it is disabled.

See also:
  `grabShortcut()`, and `releaseShortcut()`.

### setShortcutAutoRepeat

    public final void setShortcutAutoRepeat(int id,
                                            boolean enable)

  If `enable` is true, auto repeat of the shortcut with the given `id` is enabled; otherwise it is disabled.

See also:
  `grabShortcut()`, and `releaseShortcut()`.

### setShortcutEnabled

    public final void setShortcutEnabled(int id)

  If `enable` is true, the shortcut with the given `id` is enabled; otherwise the shortcut is disabled.

  Warning: You should not normally need to use this function since Qt's shortcut system enables/disables shortcuts automatically as widgets become hidden/visible and gain or lose focus. It is best to use `QAction` or `QShortcut` to handle shortcuts, since they are easier to use than this low-level function.

See also:
  `grabShortcut()`, and `releaseShortcut()`.

### setShortcutEnabled

    public final void setShortcutEnabled(int id,
                                         boolean enable)

  If `enable` is true, the shortcut with the given `id` is enabled; otherwise the shortcut is disabled.

  Warning: You should not normally need to use this function since Qt's shortcut system enables/disables shortcuts automatically as widgets become hidden/visible and gain or lose focus. It is best to use `QAction` or `QShortcut` to handle shortcuts, since they are easier to use than this low-level function.

See also:
  `grabShortcut()`, and `releaseShortcut()`.

### setSizeIncrement

    public final void setSizeIncrement(QSize arg__1)

  This property holds the size increment of the widget. When the user resizes the window, the size will move in steps of `sizeIncrement()`.`width()` pixels horizontally and `sizeIncrement`.`height()` pixels vertically, with `baseSize()` as the basis. Preferred widget sizes are for non-negative integers i and j:

              width = baseSize().width() + i * sizeIncrement().width();
              height = baseSize().height() + j * sizeIncrement().height();

  Note that while you can set the size increment for all widgets, it only affects windows.

  By default, this property contains a size with zero width and height.

  Warning: The size increment has no effect under Windows, and may be disregarded by the window manager on X11.

See also:
  `size`, `minimumSize`, and `maximumSize`.

### setSizeIncrement

    public final void setSizeIncrement(int w,
                                       int h)

  This property holds the size increment of the widget. When the user resizes the window, the size will move in steps of `sizeIncrement()`.`width()` pixels horizontally and `sizeIncrement`.`height()` pixels vertically, with `baseSize()` as the basis. Preferred widget sizes are for non-negative integers i and j:

              width = baseSize().width() + i * sizeIncrement().width();
              height = baseSize().height() + j * sizeIncrement().height();

  Note that while you can set the size increment for all widgets, it only affects windows.

  By default, this property contains a size with zero width and height.

  Warning: The size increment has no effect under Windows, and may be disregarded by the window manager on X11.

See also:
  `size`, `minimumSize`, and `maximumSize`.

### setSizePolicy

    public final void setSizePolicy(QSizePolicy arg__1)

  This property holds the default layout behavior of the widget. If there is a `QLayout` that manages this widget's children, the size policy specified by that layout is used. If there is no such `QLayout`, the result of this function is used.

  The default policy is Preferred/Preferred, which means that the widget can be freely resized, but prefers to be the size `sizeHint()` returns. Button-like widgets set the size policy to specify that they may stretch horizontally, but are fixed vertically. The same applies to lineedit controls (such as `QLineEdit`, `QSpinBox` or an editable `QComboBox`) and other horizontally orientated widgets (such as `QProgressBar`). `QToolButton`'s are normally square, so they allow growth in both directions. Widgets that support different directions (such as `QSlider`, `QScrollBar` or QHeader) specify stretching in the respective direction only. Widgets that can provide scroll bars (usually subclasses of `QScrollArea`) tend to specify that they can use additional space, and that they can make do with less than `sizeHint()`.

See also:
  `sizeHint()`, `QLayout`, `QSizePolicy`, and `updateGeometry()`.

### setSizePolicy

    public final void setSizePolicy(QSizePolicy.Policy horizontal,
                                    QSizePolicy.Policy vertical)

  This property holds the default layout behavior of the widget. If there is a `QLayout` that manages this widget's children, the size policy specified by that layout is used. If there is no such `QLayout`, the result of this function is used.

  The default policy is Preferred/Preferred, which means that the widget can be freely resized, but prefers to be the size `sizeHint()` returns. Button-like widgets set the size policy to specify that they may stretch horizontally, but are fixed vertically. The same applies to lineedit controls (such as `QLineEdit`, `QSpinBox` or an editable `QComboBox`) and other horizontally orientated widgets (such as `QProgressBar`). `QToolButton`'s are normally square, so they allow growth in both directions. Widgets that support different directions (such as `QSlider`, `QScrollBar` or QHeader) specify stretching in the respective direction only. Widgets that can provide scroll bars (usually subclasses of `QScrollArea`) tend to specify that they can use additional space, and that they can make do with less than `sizeHint()`.

See also:
  `sizeHint()`, `QLayout`, `QSizePolicy`, and `updateGeometry()`.

### setStatusTip

    public final void setStatusTip(java.lang.String arg__1)

  This property holds the widget's status tip. By default, this property contains an empty string.

See also:
  `toolTip`, and `whatsThis`.

### setStyle

    public final void setStyle(QStyle arg__1)

  Sets the widget's GUI style to `style`. The ownership of the style object is not transferred.

  If no style is set, the widget uses the application's style, `QApplication::style()` instead.

  Setting a widget's style has no effect on existing or future child widgets.

  Warning: This function is particularly useful for demonstration purposes, where you want to show Qt's styling capabilities. Real applications should avoid it and use one consistent GUI style instead.

  Warning: Qt style sheets are currently not supported for custom `QStyle` subclasses. We plan to address this in some future release.

See also:
  `style()`, `QStyle`, `QApplication::style()`, and `QApplication::setStyle()`.

### setStyleSheet

    public final void setStyleSheet(java.lang.String styleSheet)

  This property holds the widget's style sheet. The style sheet contains a textual description of customizations to the widget's style, as described in the Qt Style Sheets document.

  Note: Qt style sheets are currently not supported for QMacStyle (the default style on Mac OS X). We plan to address this in some future release.

See also:
  `setStyle()`, `QApplication::styleSheet`, and Qt Style Sheets.

### setToolTip

    public final void setToolTip(java.lang.String arg__1)

  This property holds the widget's tooltip. Note that by default tooltips are only shown for widgets that are children of the active window. You can change this behavior by setting the attribute `Qt::WA_AlwaysShowToolTips` on the window, not on the widget with the tooltip.

  If you want to control a tooltip's behavior, you can intercept the `event()` function and catch the `QEvent::ToolTip` event (e.g., if you want to customize the area for which the tooltip should be shown).

  By default, this property contains an empty string.

See also:
  `QToolTip`, `statusTip`, and `whatsThis`.

### setUpdatesEnabled

    public final void setUpdatesEnabled(boolean enable)

  This property holds whether updates are enabled. An updates enabled widget receives paint events and has a system background; a disabled widget does not. This also implies that calling `update()` and `repaint()` has no effect if updates are disabled.

  By default, this property is true.

  `setUpdatesEnabled()` is normally used to disable updates for a short period of time, for instance to avoid screen flicker during large changes. In Qt, widgets normally do not generate screen flicker, but on X11 the server might erase regions on the screen when widgets get hidden before they can be replaced by other widgets. Disabling updates solves this.

  Example:

              setUpdatesEnabled(false);
              bigVisualChanges();
              setUpdatesEnabled(true);

  Disabling a widget implicitly disables all its children. Enabling respectively enables all child widgets unless they have been explicitly disabled. Re-enabling updates implicitly calls `update()` on the widget.

See also:
  `paintEvent()`.

### setWhatsThis

    public final void setWhatsThis(java.lang.String arg__1)

  This property holds the widget's What's This help text. By default, this property contains an empty string.

See also:
  `QWhatsThis`, `QWidget::toolTip`, and `QWidget::statusTip`.

### setWindowFilePath

    public final void setWindowFilePath(java.lang.String filePath)

  This property holds the file path associated with a widget. This property only makes sense for windows. It associates a file path with a window. If you set the file path, but have not set the window title, Qt sets the window title to contain a string created using the following components.

  On Mac OS X:

  - The file name of the specified path, obtained using `QFileInfo::fileName()`.
  - An optional `*` character, if the `windowModified` property is set, as per the Apple Human Interface Guidelines.
  On Windows and X11:
  - The file name of the specified path, obtained using `QFileInfo::fileName()`.
  - An optional `*` character, if the `windowModified` property is set.
  - The `0x2014` unicode character, padded either side by spaces.
  - The application name, obtained from the application's `applicationName` property.
  If the window title is set at any point, then the window title takes precedence and will be shown instead of the file path string.

  Additionally, on Mac OS X, this has an added benefit that it sets the proxy icon for the window, assuming that the file path exists.

  If no file path is set, this property contains an empty string.

  By default, this property contains an empty string.

See also:
  `windowTitle`, and `windowIcon`.

### setWindowFlags

    public final void setWindowFlags(Qt.WindowType[] type)

  Window flags are a combination of a type (e. . `Qt::Dialog` ) and zero or more hints to the window system (e.g. `Qt::FramelessWindowHint` ).

  If the widget had type `Qt::Widget` or `Qt::SubWindow` and becomes a window (`Qt::Window` , `Qt::Dialog` , etc.), it is put at position (0, 0) on the desktop. If the widget is a window and becomes a `Qt::Widget` or `Qt::SubWindow` , it is put at position (0, 0) relative to its parent widget.

  Note: This function calls `setParent()` when changing the flags for a window, causing the widget to be hidden. You must call `show()` to make the widget visible again..

See also:
  `windowType()`, and Window Flags Example.

### setWindowFlags

    public final void setWindowFlags(Qt.WindowFlags type)

  Window flags are a combination of a type (e. . `Qt::Dialog` ) and zero or more hints to the window system (e.g. `Qt::FramelessWindowHint` ).

  If the widget had type `Qt::Widget` or `Qt::SubWindow` and becomes a window (`Qt::Window` , `Qt::Dialog` , etc.), it is put at position (0, 0) on the desktop. If the widget is a window and becomes a `Qt::Widget` or `Qt::SubWindow` , it is put at position (0, 0) relative to its parent widget.

  Note: This function calls `setParent()` when changing the flags for a window, causing the widget to be hidden. You must call `show()` to make the widget visible again..

See also:
  `windowType()`, and Window Flags Example.

### setWindowIcon

    public final void setWindowIcon(QIcon icon)

  This property holds the widget's icon. This property only makes sense for windows. If no icon has been set, `windowIcon()` returns the application icon (`QApplication::windowIcon()`).

See also:
  `windowIconText`, and `windowTitle`.

### setWindowIconText

    public final void setWindowIconText(java.lang.String arg__1)

  This property holds the widget's icon text. This property only makes sense for windows. If no icon text has been set, this functions returns an empty string.

See also:
  `windowIcon`, and `windowTitle`.

### setWindowModality

    public final void setWindowModality(Qt.WindowModality windowModality)

  This property holds which windows are blocked by the modal widget. This property only makes sense for windows. A modal widget prevents widgets in other windows from getting input. The value of this property controls which windows are blocked when the widget is visible. Changing this property while the window is visible has no effect; you must `hide()` the widget first, then `show()` it again.

  By default, this property is `Qt::NonModal` .

See also:
  `isWindow()`, `QWidget::modal`, and `QDialog`.

### setWindowModified

    public final void setWindowModified(boolean arg__1)

  This property holds whether the document shown in the window has unsaved changes. A modified window is a window whose content has changed but has not been saved to disk. This flag will have different effects varied by the platform. On Mac OS X the close button will have a modified look; on other platforms, the window title will have an '*' (asterisk).

  The window title must contain a "[*]" placeholder, which indicates where the '*' should appear. Normally, it should appear right after the file name (e.g., "document1.txt[*] - Text Editor"). If the window isn't modified, the placeholder is simply removed.

  Note that if a widget is set as modified, all its ancestors will also be set as modified. However, if you call `setWindowModified(false)` on a widget, this will not propagate to its parent because other children of the parent might have been modified.

See also:
  `windowTitle`, Application Example, SDI Example, and MDI Example.

### setWindowOpacity

    public final void setWindowOpacity(double level)

  This property holds The level of opacity for the window. The valid range of opacity is from 1.0 (completely opaque) to 0.0 (completely transparent).

  By default the value of this property is 1.0.

  This feature is available on Embedded Linux, Mac OS X, X11 platforms that support the Composite extension, and Windows 2000 and later.

  This feature is not available on Windows CE.

  Note that under X11 you need to have a composite manager running, and the X11 specific _NET_WM_WINDOW_OPACITY atom needs to be supported by the window manager you are using.

  Warning: Changing this property from opaque to transparent might issue a paint event that needs to be processed before the window is displayed correctly. This affects mainly the use of `QPixmap::grabWindow()`. Also note that semi-transparent windows update and resize significantly slower than opaque windows.

See also:
  `setMask()`.

### setWindowRole

    public final void setWindowRole(java.lang.String arg__1)

  Sets the window's role to `role`. This only makes sense for windows on X11.

See also:
  `windowRole()`.

### setWindowState

    public final void setWindowState(Qt.WindowState[] state)

  Sets the window state to `windowState`. The window state is a OR'ed combination of `Qt::WindowState` : `Qt::WindowMinimized` , `Qt::WindowMaximized` , `Qt::WindowFullScreen` , and `Qt::WindowActive` .

  If the window is not visible (i.e. `isVisible()` returns false), the window state will take effect when `show()` is called. For visible windows, the change is immediate. For example, to toggle between full-screen and normal mode, use the following code:

              Qt.WindowStates state = w.windowState();

              if (w.windowState().isSet(Qt.WindowState.WindowFullScreen))
                  state.set(Qt.WindowState.WindowFullScreen);
              else
                  state.clear(Qt.WindowState.WindowFullScreen);

              w.setWindowState(state);

  In order to restore and activate a minimized window (while preserving its maximized and/or full-screen state), use the following:

              Qt.WindowStates state= w.windowState();
              state.setValue(state.value() & ~Qt.WindowState.WindowMinimized.value() |
                                            Qt.WindowState.WindowActive.value());
              w.setWindowState(state);

  Calling this function will hide the widget. You must call `show()` to make the widget visible again.

  Note: On some window systems `Qt::WindowActive` is not immediate, and may be ignored in certain cases.

  When the window state changes, the widget receives a `changeEvent()` of type `QEvent::WindowStateChange` .

See also:
  `Qt::WindowState` , and `windowState()`.

### setWindowState

    public final void setWindowState(Qt.WindowStates state)

  Sets the window state to `windowState`. The window state is a OR'ed combination of `Qt::WindowState` : `Qt::WindowMinimized` , `Qt::WindowMaximized` , `Qt::WindowFullScreen` , and `Qt::WindowActive` .

  If the window is not visible (i.e. `isVisible()` returns false), the window state will take effect when `show()` is called. For visible windows, the change is immediate. For example, to toggle between full-screen and normal mode, use the following code:

              Qt.WindowStates state = w.windowState();

              if (w.windowState().isSet(Qt.WindowState.WindowFullScreen))
                  state.set(Qt.WindowState.WindowFullScreen);
              else
                  state.clear(Qt.WindowState.WindowFullScreen);

              w.setWindowState(state);

  In order to restore and activate a minimized window (while preserving its maximized and/or full-screen state), use the following:

              Qt.WindowStates state= w.windowState();
              state.setValue(state.value() & ~Qt.WindowState.WindowMinimized.value() |
                                            Qt.WindowState.WindowActive.value());
              w.setWindowState(state);

  Calling this function will hide the widget. You must call `show()` to make the widget visible again.

  Note: On some window systems `Qt::WindowActive` is not immediate, and may be ignored in certain cases.

  When the window state changes, the widget receives a `changeEvent()` of type `QEvent::WindowStateChange` .

See also:
  `Qt::WindowState` , and `windowState()`.

### setWindowTitle

    public final void setWindowTitle(java.lang.String arg__1)

  This property holds the window title (caption). This property only makes sense for top-level widgets, such as windows and dialogs. If no caption has been set, the title is based of the `windowFilePath`. If neither of these is set, then the title is an empty string.

  If you use the `windowModified` mechanism, the window title must contain a "[*]" placeholder, which indicates where the '*' should appear. Normally, it should appear right after the file name (e.g., "document1.txt[*] - Text Editor"). If the `windowModified` property is false (the default), the placeholder is simply removed.

See also:
  `windowIcon`, `windowIconText`, `windowModified`, and `windowFilePath`.

### show

    public final void show()

  Shows the widget and its child widgets. This function is equivalent to setVisible(true).

See also:
  `raise()`, `showEvent()`, `hide()`, `setVisible()`, `showMinimized()`, `showMaximized()`, `showNormal()`, and `isVisible()`.

### showFullScreen

    public final void showFullScreen()

  Shows the widget in full-screen mode.

  Calling this function only affects `windows`.

  To return from full-screen mode, call `showNormal()`.

  Full-screen mode works fine under Windows, but has certain problems under X. These problems are due to limitations of the ICCCM protocol that specifies the communication between X11 clients and the window manager. ICCCM simply does not understand the concept of non-decorated full-screen windows. Therefore, the best we can do is to request a borderless window and place and resize it to fill the entire screen. Depending on the window manager, this may or may not work. The borderless window is requested using MOTIF hints, which are at least partially supported by virtually all modern window managers.

  An alternative would be to bypass the window manager entirely and create a window with the `Qt::X11BypassWindowManagerHint` flag. This has other severe problems though, like totally broken keyboard focus and very strange effects on desktop changes or when the user raises other windows.

  X11 window managers that follow modern post-ICCCM specifications support full-screen mode properly.

See also:
  `showNormal()`, `showMaximized()`, `show()`, `hide()`, and `isVisible()`.

### showMaximized

    public final void showMaximized()

  Shows the widget maximized.

  Calling this function only affects `windows`.

  On X11, this function may not work properly with certain window managers. See Window Geometry for an explanation.

See also:
  `setWindowState()`, `showNormal()`, `showMinimized()`, `show()`, `hide()`, and `isVisible()`.

### showMinimized

    public final void showMinimized()

  Shows the widget minimized, as an icon.

  Calling this function only affects `windows`.

See also:
  `showNormal()`, `showMaximized()`, `show()`, `hide()`, `isVisible()`, and `isMinimized()`.

### showNormal

    public final void showNormal()

  Restores the widget after it has been maximized or minimized.

  Calling this function only affects `windows`.

See also:
  `setWindowState()`, `showMinimized()`, `showMaximized()`, `show()`, `hide()`, and `isVisible()`.

### size

    public final QSize size()

  This property holds the size of the widget excluding any window frame. If the widget is visible when it is being resized, it receives a resize event (`resizeEvent()`) immediately. If the widget is not currently visible, it is guaranteed to receive an event before it is shown.

  The size is adjusted if it lies outside the range defined by `minimumSize()` and `maximumSize()`.

  By default, this property contains a value that depends on the user's platform and screen geometry.

  Warning: Calling `resize()` or `setGeometry()` inside `resizeEvent()` can lead to infinite recursion.

  Note: Setting the size to `QSize(0, 0)` will cause the widget to not appear on screen. This also applies to windows.

See also:
  `pos`, `geometry`, `minimumSize`, `maximumSize`, and `resizeEvent()`.

### sizeIncrement

    public final QSize sizeIncrement()

  This property holds the size increment of the widget. When the user resizes the window, the size will move in steps of `sizeIncrement()`.`width()` pixels horizontally and `sizeIncrement`.`height()` pixels vertically, with `baseSize()` as the basis. Preferred widget sizes are for non-negative integers i and j:

              width = baseSize().width() + i * sizeIncrement().width();
              height = baseSize().height() + j * sizeIncrement().height();

  Note that while you can set the size increment for all widgets, it only affects windows.

  By default, this property contains a size with zero width and height.

  Warning: The size increment has no effect under Windows, and may be disregarded by the window manager on X11.

See also:
  `size`, `minimumSize`, and `maximumSize`.

### sizePolicy

    public final QSizePolicy sizePolicy()

  This property holds the default layout behavior of the widget. If there is a `QLayout` that manages this widget's children, the size policy specified by that layout is used. If there is no such `QLayout`, the result of this function is used.

  The default policy is Preferred/Preferred, which means that the widget can be freely resized, but prefers to be the size `sizeHint()` returns. Button-like widgets set the size policy to specify that they may stretch horizontally, but are fixed vertically. The same applies to lineedit controls (such as `QLineEdit`, `QSpinBox` or an editable `QComboBox`) and other horizontally orientated widgets (such as `QProgressBar`). `QToolButton`'s are normally square, so they allow growth in both directions. Widgets that support different directions (such as `QSlider`, `QScrollBar` or QHeader) specify stretching in the respective direction only. Widgets that can provide scroll bars (usually subclasses of `QScrollArea`) tend to specify that they can use additional space, and that they can make do with less than `sizeHint()`.

See also:
  `sizeHint()`, `QLayout`, `QSizePolicy`, and `updateGeometry()`.

### stackUnder

    public final void stackUnder(QWidget arg__1)

  Places the widget under `w` in the parent widget's stack.

  To make this work, the widget itself and `w` must be siblings.

See also:
  `raise()`, and `lower()`.

### statusTip

    public final java.lang.String statusTip()

  This property holds the widget's status tip. By default, this property contains an empty string.

See also:
  `toolTip`, and `whatsThis`.

### style

    public final QStyle style()

  Returns the widget's style object, i.e., the style in which the widget is drawn.

### styleSheet

    public final java.lang.String styleSheet()

  This property holds the widget's style sheet. The style sheet contains a textual description of customizations to the widget's style, as described in the Qt Style Sheets document.

  Note: Qt style sheets are currently not supported for QMacStyle (the default style on Mac OS X). We plan to address this in some future release.

See also:
  `setStyle()`, `QApplication::styleSheet`, and Qt Style Sheets.

### testAttribute

    public final boolean testAttribute(Qt.WidgetAttribute arg__1)

  Returns true if attribute `attribute` is set on this widget; otherwise returns false.

See also:
  `setAttribute()`.

### toolTip

    public final java.lang.String toolTip()

  This property holds the widget's tooltip. Note that by default tooltips are only shown for widgets that are children of the active window. You can change this behavior by setting the attribute `Qt::WA_AlwaysShowToolTips` on the window, not on the widget with the tooltip.

  If you want to control a tooltip's behavior, you can intercept the `event()` function and catch the `QEvent::ToolTip` event (e.g., if you want to customize the area for which the tooltip should be shown).

  By default, this property contains an empty string.

See also:
  `QToolTip`, `statusTip`, and `whatsThis`.

### underMouse

    public final boolean underMouse()

  Returns true if the widget is under the mouse cursor; otherwise returns false.

  This value is not updated properly during drag and drop operations.

See also:
  `enterEvent()`, and `leaveEvent()`.

### unsetCursor

    public final void unsetCursor()

  This property holds the cursor shape for this widget. The mouse cursor will assume this shape when it's over this widget. See the `list of predefined cursor objects` for a range of useful shapes.

  An editor widget might use an I-beam cursor:

              w.setCursor(new QCursor(Qt.CursorShape.IBeamCursor));

  If no cursor has been set, or after a call to `unsetCursor()`, the parent's cursor is used.

  By default, this property contains a cursor with the `Qt::ArrowCursor` shape.

See also:
  `QApplication::setOverrideCursor()`.

### unsetLayoutDirection

    public final void unsetLayoutDirection()

  This property holds the layout direction for this widget. By default, this property is set to `Qt::LeftToRight` .

See also:
  `QApplication::layoutDirection`.

### unsetLocale

    public final void unsetLocale()

  This property holds the widget's locale. As long as no special locale has been set, this is either the parent's locale or (if this widget is a top level widget), the default locale.

  If the widget displays dates or numbers, these should be formatted using the widget's locale.

See also:
  `QLocale`, and `QLocale::setDefault()`.

### update

    public final void update()

  Updates the widget unless updates are disabled or the widget is hidden.

  This function does not cause an immediate repaint; instead it schedules a paint event for processing when Qt returns to the main event loop. This permits Qt to optimize for more speed and less flicker than a call to `repaint()` does.

  Calling `update()` several times normally results in just one `paintEvent()` call.

  Qt normally erases the widget's area before the `paintEvent()` call. If the `Qt::WA_OpaquePaintEvent` widget attribute is set, the widget is responsible for painting all its pixels with an opaque color.

See also:
  `repaint()`, `paintEvent()`, `setUpdatesEnabled()`, and Analog Clock Example.

### update

    public final void update(QRect arg__1)

  This version updates a rectangle `r` inside the widget.

### update

    public final void update(QRegion arg__1)

  This version repaints a region `rgn` inside the widget.

### update

    public final void update(int x,
                             int y,
                             int w,
                             int h)

  This version updates a rectangle (`x`, `y`, `w`, `h`) inside the widget.

### updateGeometry

    public final void updateGeometry()

  Notifies the layout system that this widget has changed and may need to change geometry.

  Call this function if the `sizeHint()` or `sizePolicy()` have changed.

  For explicitly hidden widgets, `updateGeometry()` is a no-op. The layout system will be notified as soon as the widget is shown.

### updateMicroFocus

    protected final void updateMicroFocus()

  Updates the widget's micro focus.

See also:
  `QInputContext`.

### updatesEnabled

    public final boolean updatesEnabled()

  This property holds whether updates are enabled. An updates enabled widget receives paint events and has a system background; a disabled widget does not. This also implies that calling `update()` and `repaint()` has no effect if updates are disabled.

  By default, this property is true.

  `setUpdatesEnabled()` is normally used to disable updates for a short period of time, for instance to avoid screen flicker during large changes. In Qt, widgets normally do not generate screen flicker, but on X11 the server might erase regions on the screen when widgets get hidden before they can be replaced by other widgets. Disabling updates solves this.

  Example:

              setUpdatesEnabled(false);
              bigVisualChanges();
              setUpdatesEnabled(true);

  Disabling a widget implicitly disables all its children. Enabling respectively enables all child widgets unless they have been explicitly disabled. Re-enabling updates implicitly calls `update()` on the widget.

See also:
  `paintEvent()`.

### visibleRegion

    public final QRegion visibleRegion()

  Returns the unobscured region where paint events can occur.

  For visible widgets, this is an approximation of the area not covered by other widgets; otherwise, this is an empty region.

  The `repaint()` function calls this function if necessary, so in general you do not need to call it.

### whatsThis

    public final java.lang.String whatsThis()

  This property holds the widget's What's This help text. By default, this property contains an empty string.

See also:
  `QWhatsThis`, `QWidget::toolTip`, and `QWidget::statusTip`.

### width

    public final int width()

  Returns the width of the paint device in default coordinate system units (e. . pixels for `QPixmap` and `QWidget`).

See also:
  `widthMM()`.

  Specified by:
    `width` in interface `QPaintDeviceInterface`

### widthMM

    public final int widthMM()

  Returns the width of the paint device in millimeters.

See also:
  `width()`.

  Specified by:
    `widthMM` in interface `QPaintDeviceInterface`

### winId

    public final long winId()

  Returns the window system identifier of the widget.

  Portable in principle, but if you use it you are probably about to do something non-portable. Be careful.

  Note: We recommend that you do not store this value as it is likely to change during run-time.

See also:
  find().

### window

    public final QWidget window()

  Returns the window for this widget, i. . the next ancestor widget that has (or could have) a window-system frame.

  If the widget is a window, the widget itself is returned.

  Typical usage is changing the window title:

              aWidget.window().setWindowTitle("New Window Title");

See also:
  `isWindow()`.

### windowFilePath

    public final java.lang.String windowFilePath()

  This property holds the file path associated with a widget. This property only makes sense for windows. It associates a file path with a window. If you set the file path, but have not set the window title, Qt sets the window title to contain a string created using the following components.

  On Mac OS X:

  - The file name of the specified path, obtained using `QFileInfo::fileName()`.
  - An optional `*` character, if the `windowModified` property is set, as per the Apple Human Interface Guidelines.
  On Windows and X11:
  - The file name of the specified path, obtained using `QFileInfo::fileName()`.
  - An optional `*` character, if the `windowModified` property is set.
  - The `0x2014` unicode character, padded either side by spaces.
  - The application name, obtained from the application's `applicationName` property.
  If the window title is set at any point, then the window title takes precedence and will be shown instead of the file path string.

  Additionally, on Mac OS X, this has an added benefit that it sets the proxy icon for the window, assuming that the file path exists.

  If no file path is set, this property contains an empty string.

  By default, this property contains an empty string.

See also:
  `windowTitle`, and `windowIcon`.

### windowFlags

    public final Qt.WindowFlags windowFlags()

  Window flags are a combination of a type (e. . `Qt::Dialog` ) and zero or more hints to the window system (e.g. `Qt::FramelessWindowHint` ).

  If the widget had type `Qt::Widget` or `Qt::SubWindow` and becomes a window (`Qt::Window` , `Qt::Dialog` , etc.), it is put at position (0, 0) on the desktop. If the widget is a window and becomes a `Qt::Widget` or `Qt::SubWindow` , it is put at position (0, 0) relative to its parent widget.

  Note: This function calls `setParent()` when changing the flags for a window, causing the widget to be hidden. You must call `show()` to make the widget visible again..

See also:
  `windowType()`, and Window Flags Example.

### windowIcon

    public final QIcon windowIcon()

  This property holds the widget's icon. This property only makes sense for windows. If no icon has been set, `windowIcon()` returns the application icon (`QApplication::windowIcon()`).

See also:
  `windowIconText`, and `windowTitle`.

### windowIconText

    public final java.lang.String windowIconText()

  This property holds the widget's icon text. This property only makes sense for windows. If no icon text has been set, this functions returns an empty string.

See also:
  `windowIcon`, and `windowTitle`.

### windowModality

    public final Qt.WindowModality windowModality()

  This property holds which windows are blocked by the modal widget. This property only makes sense for windows. A modal widget prevents widgets in other windows from getting input. The value of this property controls which windows are blocked when the widget is visible. Changing this property while the window is visible has no effect; you must `hide()` the widget first, then `show()` it again.

  By default, this property is `Qt::NonModal` .

See also:
  `isWindow()`, `QWidget::modal`, and `QDialog`.

### windowOpacity

    public final double windowOpacity()

  This property holds The level of opacity for the window. The valid range of opacity is from 1.0 (completely opaque) to 0.0 (completely transparent).

  By default the value of this property is 1.0.

  This feature is available on Embedded Linux, Mac OS X, X11 platforms that support the Composite extension, and Windows 2000 and later.

  This feature is not available on Windows CE.

  Note that under X11 you need to have a composite manager running, and the X11 specific _NET_WM_WINDOW_OPACITY atom needs to be supported by the window manager you are using.

  Warning: Changing this property from opaque to transparent might issue a paint event that needs to be processed before the window is displayed correctly. This affects mainly the use of `QPixmap::grabWindow()`. Also note that semi-transparent windows update and resize significantly slower than opaque windows.

See also:
  `setMask()`.

### windowRole

    public final java.lang.String windowRole()

  Returns the window's role, or an empty string.

See also:
  `setWindowRole()`, `windowIcon`, and `windowTitle`.

### windowState

    public final Qt.WindowStates windowState()

  Returns the current window state. The window state is a OR'ed combination of `Qt::WindowState` : `Qt::WindowMinimized` , `Qt::WindowMaximized` , `Qt::WindowFullScreen` , and `Qt::WindowActive` .

See also:
  `Qt::WindowState` , and `setWindowState()`.

### windowTitle

    public final java.lang.String windowTitle()

  This property holds the window title (caption). This property only makes sense for top-level widgets, such as windows and dialogs. If no caption has been set, the title is based of the `windowFilePath`. If neither of these is set, then the title is an empty string.

  If you use the `windowModified` mechanism, the window title must contain a "[*]" placeholder, which indicates where the '*' should appear. Normally, it should appear right after the file name (e.g., "document1.txt[*] - Text Editor"). If the `windowModified` property is false (the default), the placeholder is simply removed.

See also:
  `windowIcon`, `windowIconText`, `windowModified`, and `windowFilePath`.

### windowType

    public final Qt.WindowType windowType()

  Returns the window type of this widget. This is identical to `windowFlags()` & `Qt::WindowType_Mask` .

See also:
  `windowFlags`.

### x

    public final int x()

  This property holds the x coordinate of the widget relative to its parent including any window frame. See the Window Geometry documentation for an overview of window geometry.

  By default, this property has a value of 0.

See also:
  `frameGeometry`, `y`, and `pos`.

### y

    public final int y()

  This property holds the y coordinate of the widget relative to its parent and including any window frame. See the Window Geometry documentation for an overview of window geometry.

  By default, this property has a value of 0.

See also:
  `frameGeometry`, `x`, and `pos`.

### actionEvent

    protected void actionEvent(QActionEvent arg__1)

  This event handler is called with the given `event` whenever the widget's actions are changed.

See also:
  `addAction()`, `insertAction()`, `removeAction()`, `actions()`, and `QActionEvent`.

### changeEvent

    protected void changeEvent(QEvent arg__1)

  This event handler can be reimplemented to handle state changes.

  The state being changed in this event can be retrieved through event `event`.

  Change events include: `QEvent::ToolBarChange` , `QEvent::ActivationChange` , `QEvent::EnabledChange` , `QEvent::FontChange` , `QEvent::StyleChange` , `QEvent::PaletteChange` , `QEvent::WindowTitleChange` , `QEvent::IconTextChange` , `QEvent::ModifiedChange` , `QEvent::MouseTrackingChange` , `QEvent::ParentChange` , `QEvent::WindowStateChange` , `QEvent::LanguageChange` , `QEvent::LocaleChange` , `QEvent::LayoutDirectionChange` .

### closeEvent

    protected void closeEvent(QCloseEvent arg__1)

  This event handler is called with the given `event` when Qt receives a window close request for a top-level widget from the window system.

  By default, the event is accepted and the widget is closed. You can reimplement this function to change the way the widget responds to window close requests. For example, you can prevent the window from closing by calling `ignore()` on all events.

  Main window applications typically use reimplementations of this function to check whether the user's work has been saved and ask for permission before closing. For example, the Application Example uses a helper function to determine whether or not to close the window:
  The following code example is written in c++.

      void MainWindow::closeEvent(QCloseEvent *event)

      {
          if (maybeSave()) {
              writeSettings();
              event->accept();
          } else {
              event->ignore();
          }
      }

See also:
  `event()`, `hide()`, `close()`, `QCloseEvent`, and Application Example.

### contextMenuEvent

    protected void contextMenuEvent(QContextMenuEvent arg__1)

  This event handler, for event `event`, can be reimplemented in a subclass to receive widget context menu events.

  The handler is called when the widget's `contextMenuPolicy` is `Qt::DefaultContextMenu` .

  The default implementation ignores the context event. See the `QContextMenuEvent` documentation for more details.

See also:
  `event()`, `QContextMenuEvent`, and `customContextMenuRequested()` .

### dragEnterEvent

    protected void dragEnterEvent(QDragEnterEvent arg__1)

  This event handler is called when a drag is in progress and the mouse enters this widget. The event is passed in the `event` parameter.

  If the event is ignored, the widget won't receive any `drag move events`.

  See the Drag-and-drop documentation for an overview of how to provide drag-and-drop in your application.

See also:
  `QDrag`, and `QDragEnterEvent`.

### dragLeaveEvent

    protected void dragLeaveEvent(QDragLeaveEvent arg__1)

  This event handler is called when a drag is in progress and the mouse leaves this widget. The event is passed in the `event` parameter.

  See the Drag-and-drop documentation for an overview of how to provide drag-and-drop in your application.

See also:
  `QDrag`, and `QDragLeaveEvent`.

### dragMoveEvent

    protected void dragMoveEvent(QDragMoveEvent arg__1)

  This event handler is called if a drag is in progress, and when any of the following conditions occur. the cursor enters this widget, the cursor moves within this widget, or a modifier key is pressed on the keyboard while this widget has the focus. The event is passed in the `event` parameter.

  See the Drag-and-drop documentation for an overview of how to provide drag-and-drop in your application.

See also:
  `QDrag`, and `QDragMoveEvent`.

### dropEvent

    protected void dropEvent(QDropEvent arg__1)

  This event handler is called when the drag is dropped on this widget. The event is passed in the `event` parameter.

  See the Drag-and-drop documentation for an overview of how to provide drag-and-drop in your application.

See also:
  `QDrag`, and `QDropEvent`.

### enterEvent

    protected void enterEvent(QEvent arg__1)

  This event handler can be reimplemented in a subclass to receive widget enter events which are passed in the `event` parameter.

  An event is sent to the widget when the mouse cursor enters the widget.

See also:
  `leaveEvent()`, `mouseMoveEvent()`, and `event()`.

### focusInEvent

    protected void focusInEvent(QFocusEvent arg__1)

  This event handler can be reimplemented in a subclass to receive keyboard focus events (focus received) for the widget. The event is passed in the `event` parameter

  A widget normally must `setFocusPolicy()` to something other than `Qt::NoFocus` in order to receive focus events. (Note that the application programmer can call `setFocus()` on any widget, even those that do not normally accept focus.)

  The default implementation updates the widget (except for windows that do not specify a `focusPolicy()`).

See also:
  `focusOutEvent()`, `setFocusPolicy()`, `keyPressEvent()`, `keyReleaseEvent()`, `event()`, and `QFocusEvent`.

### focusNextPrevChild

    protected boolean focusNextPrevChild(boolean next)

  Finds a new widget to give the keyboard focus to, as appropriate for Tab and Shift+Tab, and returns true if it can find a new widget, or false if it can't.

  If `next` is true, this function searches forward, if `next` is false, it searches backward.

  Sometimes, you will want to reimplement this function. For example, a web browser might reimplement it to move its "current active link" forward or backward, and call `focusNextPrevChild()` only when it reaches the last or first link on the "page".

  Child widgets call `focusNextPrevChild()` on their parent widgets, but only the window that contains the child widgets decides where to redirect focus. By reimplementing this function for an object, you thus gain control of focus traversal for all child widgets.

See also:
  `focusNextChild()`, and `focusPreviousChild()`.

### focusOutEvent

    protected void focusOutEvent(QFocusEvent arg__1)

  This event handler can be reimplemented in a subclass to receive keyboard focus events (focus lost) for the widget. The events is passed in the `event` parameter.

  A widget normally must `setFocusPolicy()` to something other than `Qt::NoFocus` in order to receive focus events. (Note that the application programmer can call `setFocus()` on any widget, even those that do not normally accept focus.)

  The default implementation updates the widget (except for windows that do not specify a `focusPolicy()`).

See also:
  `focusInEvent()`, `setFocusPolicy()`, `keyPressEvent()`, `keyReleaseEvent()`, `event()`, and `QFocusEvent`.

### heightForWidth

    public int heightForWidth(int arg__1)

  Returns the preferred height for this widget, given the width `w`.

  If this widget has a layout, the default implementation returns the layout's preferred height. if there is no layout, the default implementation returns -1 indicating that the preferred height does not depend on the width.

### hideEvent

    protected void hideEvent(QHideEvent arg__1)

  This event handler can be reimplemented in a subclass to receive widget hide events. The event is passed in the `event` parameter.

  Hide events are sent to widgets immediately after they have been hidden.

  Note: A widget receives spontaneous show and hide events when its mapping status is changed by the window system, e.g. a spontaneous hide event when the user minimizes the window, and a spontaneous show event when the window is restored again. After receiving a spontaneous hide event, a widget is still considered visible in the sense of `isVisible()`.

See also:
  `visible`, `event()`, and `QHideEvent`.

### inputMethodEvent

    protected void inputMethodEvent(QInputMethodEvent arg__1)

  This event handler, for event `event`, can be reimplemented in a subclass to receive Input Method composition events. This handler is called when the state of the input method changes.

  Note that when creating custom text editing widgets, the `Qt::WA_InputMethodEnabled` window attribute must be set explicitly (using the `setAttribute()` function) in order to receive input method events.

  The default implementation calls event->ignore(), which rejects the Input Method event. See the `QInputMethodEvent` documentation for more details.

See also:
  `event()`, and `QInputMethodEvent`.

### inputMethodQuery

    public java.lang.Object inputMethodQuery(Qt.InputMethodQuery arg__1)

  This method is only relevant for input widgets. It is used by the input method to query a set of properties of the widget to be able to support complex input method operations as support for surrounding text and reconversions.

  `query` specifies which property is queried.

See also:
  `inputMethodEvent()`, `QInputMethodEvent`, and `QInputContext`.

### keyPressEvent

    protected void keyPressEvent(QKeyEvent arg__1)

  This event handler, for event `event`, can be reimplemented in a subclass to receive key press events for the widget.

  A widget must call `setFocusPolicy()` to accept focus initially and have focus in order to receive a key press event.

  If you reimplement this handler, it is very important that you call the base class implementation if you do not act upon the key.

  The default implementation closes popup widgets if the user presses Esc. Otherwise the event is ignored, so that the widget's parent can interpret it.

  Note that `QKeyEvent` starts with isAccepted() == true, so you do not need to call `QKeyEvent::accept()` - just do not call the base class implementation if you act upon the key.

See also:
  `keyReleaseEvent()`, `setFocusPolicy()`, `focusInEvent()`, `focusOutEvent()`, `event()`, `QKeyEvent`, and Tetrix Example.

### keyReleaseEvent

    protected void keyReleaseEvent(QKeyEvent arg__1)

  This event handler, for event `event`, can be reimplemented in a subclass to receive key release events for the widget.

  A widget must `accept focus` initially and `have focus` in order to receive a key release event.

  If you reimplement this handler, it is very important that you call the base class implementation if you do not act upon the key.

  The default implementation ignores the event, so that the widget's parent can interpret it.

  Note that `QKeyEvent` starts with isAccepted() == true, so you do not need to call `QKeyEvent::accept()` - just do not call the base class implementation if you act upon the key.

See also:
  `keyPressEvent()`, `QKeyEvent::ignore()`, `setFocusPolicy()`, `focusInEvent()`, `focusOutEvent()`, `event()`, and `QKeyEvent`.

### languageChange

    protected void languageChange()

### leaveEvent

    protected void leaveEvent(QEvent arg__1)

  This event handler can be reimplemented in a subclass to receive widget leave events which are passed in the `event` parameter.

  A leave event is sent to the widget when the mouse cursor leaves the widget.

See also:
  `enterEvent()`, `mouseMoveEvent()`, and `event()`.

### metric

    public int metric(QPaintDevice.PaintDeviceMetric arg__1)

  Returns the metric information for the given paint device `metric`.

See also:
  `PaintDeviceMetric` .

  Specified by:
    `metric` in interface `QPaintDeviceInterface`

### minimumSizeHint

    public QSize minimumSizeHint()

  This property holds the recommended minimum size for the widget. If the value of this property is an invalid size, no minimum size is recommended.

  The default implementation of `minimumSizeHint()` returns an invalid size if there is no layout for this widget, and returns the layout's minimum size otherwise. Most built-in widgets reimplement `minimumSizeHint()`.

  `QLayout` will never resize a widget to a size smaller than the minimum size hint unless `minimumSize()` is set or the size policy is set to QSizePolicy::Ignore. If `minimumSize()` is set, the minimum size hint will be ignored.

See also:
  `QSize::isValid()`, `resize()`, `setMinimumSize()`, and `sizePolicy()`.

### mouseDoubleClickEvent

    protected void mouseDoubleClickEvent(QMouseEvent arg__1)

  This event handler, for event `event`, can be reimplemented in a subclass to receive mouse double click events for the widget.

  The default implementation generates a normal mouse press event.

  Note that the widgets gets a `mousePressEvent()` and a `mouseReleaseEvent()` before the `mouseDoubleClickEvent()`.

See also:
  `mousePressEvent()`, `mouseReleaseEvent()`, `mouseMoveEvent()`, `event()`, and `QMouseEvent`.

### mouseMoveEvent

    protected void mouseMoveEvent(QMouseEvent arg__1)

  This event handler, for event `event`, can be reimplemented in a subclass to receive mouse move events for the widget.

  If mouse tracking is switched off, mouse move events only occur if a mouse button is pressed while the mouse is being moved. If mouse tracking is switched on, mouse move events occur even if no mouse button is pressed.

  `QMouseEvent::pos()` reports the position of the mouse cursor, relative to this widget. For press and release events, the position is usually the same as the position of the last mouse move event, but it might be different if the user's hand shakes. This is a feature of the underlying window system, not Qt.

See also:
  `setMouseTracking()`, `mousePressEvent()`, `mouseReleaseEvent()`, `mouseDoubleClickEvent()`, `event()`, `QMouseEvent`, and Scribble Example.

### mousePressEvent

    protected void mousePressEvent(QMouseEvent arg__1)

  This event handler, for event `event`, can be reimplemented in a subclass to receive mouse press events for the widget.

  If you create new widgets in the `mousePressEvent()` the `mouseReleaseEvent()` may not end up where you expect, depending on the underlying window system (or X11 window manager), the widgets' location and maybe more.

  The default implementation implements the closing of popup widgets when you click outside the window. For other widget types it does nothing.

See also:
  `mouseReleaseEvent()`, `mouseDoubleClickEvent()`, `mouseMoveEvent()`, `event()`, `QMouseEvent`, and Scribble Example.

### mouseReleaseEvent

    protected void mouseReleaseEvent(QMouseEvent arg__1)

  This event handler, for event `event`, can be reimplemented in a subclass to receive mouse release events for the widget.

See also:
  `mousePressEvent()`, `mouseDoubleClickEvent()`, `mouseMoveEvent()`, `event()`, `QMouseEvent`, and Scribble Example.

### moveEvent

    protected void moveEvent(QMoveEvent arg__1)

  This event handler can be reimplemented in a subclass to receive widget move events which are passed in the `event` parameter. When the widget receives this event, it is already at the new position.

  The old position is accessible through `QMoveEvent::oldPos()`.

See also:
  `resizeEvent()`, `event()`, `move()`, and `QMoveEvent`.

### paintEngine

    public QPaintEngine paintEngine()

  Returns a pointer to the paint engine used for drawing on the device.

  Specified by:
    `paintEngine` in interface `QPaintDeviceInterface`

### paintEvent

    protected void paintEvent(QPaintEvent arg__1)

  This event handler can be reimplemented in a subclass to receive paint events which are passed in the `event` parameter.

  A paint event is a request to repaint all or part of the widget. It can happen as a result of `repaint()` or `update()`, or because the widget was obscured and has now been uncovered, or for many other reasons.

  Many widgets can simply repaint their entire surface when asked to, but some slow widgets need to optimize by painting only the requested region: `QPaintEvent::region()`. This speed optimization does not change the result, as painting is clipped to that region during event processing. `QListView` and `QTableView` do this, for example.

  Qt also tries to speed up painting by merging multiple paint events into one. When `update()` is called several times or the window system sends several paint events, Qt merges these events into one event with a larger region (see `QRegion::united()`). `repaint()` does not permit this optimization, so we suggest using `update()` whenever possible.

  When the paint event occurs, the update region has normally been erased, so that you're painting on the widget's background.

  The background can be set using `setBackgroundRole()` and `setPalette()`.

  From Qt 4.0, `QWidget` automatically double-buffers its painting, so there's no need to write double-buffering code in `paintEvent()` to avoid flicker.

  Note: Under X11 it is possible to toggle the global double buffering by calling `qt_x11_set_global_double_buffer()`. Example usage:

          This code is not relevant for Qt Jambi
          ...
          extern void qt_x11_set_global_double_buffer(bool);
          qt_x11_set_global_double_buffer(false);
          ...

  Note: In general, one should refrain from calling `update()` or `repaint()`inside of `paintEvent()`. For example, calling `update()` or `repaint()` on children inside a `paintEvent()` results in undefined behavior; the child may or may not get a paint event.

See also:
  `event()`, `repaint()`, `update()`, `QPainter`, `QPixmap`, `QPaintEvent`, and Analog Clock Example.

### resizeEvent

    protected void resizeEvent(QResizeEvent arg__1)

  This event handler can be reimplemented in a subclass to receive widget resize events which are passed in the `event` parameter. When `resizeEvent()` is called, the widget already has its new geometry. The old size is accessible through `QResizeEvent::oldSize()`.

  The widget will be erased and receive a paint event immediately after processing the resize event. No drawing need be (or should be) done inside this handler.

See also:
  `moveEvent()`, `event()`, `resize()`, `QResizeEvent`, `paintEvent()`, and Scribble Example.

### setVisible

    public void setVisible(boolean visible)

  This property holds whether the widget is visible. Calling setVisible(true) or `show()` sets the widget to visible status if all its parent widgets up to the window are visible. If an ancestor is not visible, the widget won't become visible until all its ancestors are shown. If its size or position has changed, Qt guarantees that a widget gets move and resize events just before it is shown. If the widget has not been resized yet, Qt will adjust the widget's size to a useful default using `adjustSize()`.

  Calling setVisible(false) or `hide()` hides a widget explicitly. An explicitly hidden widget will never become visible, even if all its ancestors become visible, unless you show it.

  A widget receives show and hide events when its visibility status changes. Between a hide and a show event, there is no need to waste CPU cycles preparing or displaying information to the user. A video application, for example, might simply stop generating new frames.

  A widget that happens to be obscured by other windows on the screen is considered to be visible. The same applies to iconified windows and windows that exist on another virtual desktop (on platforms that support this concept). A widget receives spontaneous show and hide events when its mapping status is changed by the window system, e.g. a spontaneous hide event when the user minimizes the window, and a spontaneous show event when the window is restored again.

  You almost never have to reimplement the `setVisible()` function. If you need to change some settings before a widget is shown, use `showEvent()` instead. If you need to do some delayed initialization use the Polish event delivered to the `event()` function.

See also:
  `show()`, `hide()`, `isHidden()`, `isVisibleTo()`, `isMinimized()`, `showEvent()`, and `hideEvent()`.

### showEvent

    protected void showEvent(QShowEvent arg__1)

  This event handler can be reimplemented in a subclass to receive widget show events which are passed in the `event` parameter.

  Non-spontaneous show events are sent to widgets immediately before they are shown. The spontaneous show events of windows are delivered afterwards.

  Note: A widget receives spontaneous show and hide events when its mapping status is changed by the window system, e.g. a spontaneous hide event when the user minimizes the window, and a spontaneous show event when the window is restored again. After receiving a spontaneous hide event, a widget is still considered visible in the sense of `isVisible()`.

See also:
  `visible`, `event()`, and `QShowEvent`.

### sizeHint

    public QSize sizeHint()

  This property holds the recommended size for the widget. If the value of this property is an invalid size, no size is recommended.

  The default implementation of `sizeHint()` returns an invalid size if there is no layout for this widget, and returns the layout's preferred size otherwise.

See also:
  `QSize::isValid()`, `minimumSizeHint()`, `sizePolicy()`, `setMinimumSize()`, and `updateGeometry()`.

### tabletEvent

    protected void tabletEvent(QTabletEvent arg__1)

  This event handler, for event `event`, can be reimplemented in a subclass to receive tablet events for the widget.

  If you reimplement this handler, it is very important that you `ignore()` the event if you do not handle it, so that the widget's parent can interpret it.

  The default implementation ignores the event.

See also:
  `QTabletEvent::ignore()`, `QTabletEvent::accept()`, `event()`, and `QTabletEvent`.

### wheelEvent

    protected void wheelEvent(QWheelEvent arg__1)

  This event handler, for event `event`, can be reimplemented in a subclass to receive wheel events for the widget.

  If you reimplement this handler, it is very important that you `ignore()` the event if you do not handle it, so that the widget's parent can interpret it.

  The default implementation ignores the event.

See also:
  `QWheelEvent::ignore()`, `QWheelEvent::accept()`, `event()`, and `QWheelEvent`.

### keyboardGrabber

    public static QWidget keyboardGrabber()

  Returns the widget that is currently grabbing the keyboard input.

  If no widget in this application is currently grabbing the keyboard, 0 is returned.

See also:
  `grabMouse()`, and `mouseGrabber()`.

### mouseGrabber

    public static QWidget mouseGrabber()

  Returns the widget that is currently grabbing the mouse input.

  If no widget in this application is currently grabbing the mouse, 0 is returned.

See also:
  `grabMouse()`, and `keyboardGrabber()`.

### setTabOrder

    public static void setTabOrder(QWidget arg__1,
                                   QWidget arg__2)

  Moves the `second` widget around the ring of focus widgets so that keyboard focus moves from the `first` widget to the `second` widget when the Tab key is pressed.

  Note that since the tab order of the `second` widget is changed, you should order a chain like this:

              setTabOrder(a, b); // a to b
              setTabOrder(b, c); // a to b to c
              setTabOrder(c, d); // a to b to c to d

  not like this:

              // WRONG
              setTabOrder(c, d); // c to d
              setTabOrder(a, b); // a to b AND c to d
              setTabOrder(b, c); // a to b to c, but not c to d

  If `first` or `second` has a focus proxy, `setTabOrder()` correctly substitutes the proxy.

See also:
  `setFocusPolicy()`, `setFocusProxy()`, and Keyboard Focus.

### getContentsMargins

    public final com.trolltech.qt.gui.QContentsMargins getContentsMargins()

  Returns the widget's contents margins.

### setContentsMargins

    public final void setContentsMargins(com.trolltech.qt.gui.QContentsMargins margins)

  Sets the `margins` around the contents of the widget. The margins are used by the layout system, and may be used by subclasses to specify the area to draw in (e.g. excluding the frame).

  Changing the margins will trigger a resizeEvent().

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD